((Themify,win,vars) => {
    'use strict';
    const src=new URL(document.currentScript.src,win.location.origin),
        VER=src.searchParams.get('ver'),
        tmp = src.href.split('?')[0].split('/').slice(0,-1),
        _URL=(tmp.join('/')+'/'),
        pageType=vars.template;
        
    Themify.on('tb_layout_loaded',(LayoutList,webp)=>{
            class ProLayout extends LayoutList{
                constructor(){
                    const id='pro';
                    super(id);
                    this.id=id;
                    this.title=vars.pro_layout;
                    if(pageType==='footer' || pageType==='header'){
                        this.imgW=440;
                        this.imgH=50;
                    }
                }
                async getList(){
                    await Themify.loadJs(_URL+'predesigned',!!win.TBP_Predesigned,VER);
                    const data =await TBP_Predesigned.getTemplates(pageType);
                    if(data){
                        const res=[];
                        for (let i = 0, len = data.length; i < len; ++i) {
                            res[i]={
                                title:data[i].post_title || data[i].title.rendered,
                                slug: data[i].slug
                            };
                            if(data[i].tbp_image_full){
                                res[i].thumbnail=data[i].tbp_image_full;
                            }
                        }
                        return res;
                    }
                        
                }
                async getItem(slug){
                    await Themify.loadJs(_URL+'predesigned',!!win.TBP_Predesigned,VER);
                    let res=await TBP_Predesigned.getTemplate(slug);
                    res=res[0];
                    const data = { builder_data : JSON.parse( res.template_builder_content ) };
                    if(res.tbp_template_gs){
                        data.used_gs=res.tbp_template_gs;
                        for(let k in data.used_gs){
                            delete data.used_gs[k].id;
                            delete data.used_gs[k].url;
                        }
                    }
                    return data;
                }
            }
            setTimeout(()=>{//when Pro template is activate,only selected type(header,footer,single product and etc) can be applied
                LayoutList.instanes.clear();
                new ProLayout();
            },5);
    },true);
    
})(Themify,window,tbp_local);