let TBP_ExportFile;
((Themify,win)=> {
    'use strict';
    
    TBP_ExportFile={
        getData(id,vars){
            return Themify.fetch({
                action :'tbp_export',
                id: id,
                nonce: vars.nonce
            }).then(res=>{
                if(!res || !res.success || !res.data){
                    throw 'error';
                }
                return res;
            });
        },
        init(ids,type,vars){
            return new Promise(async(resolve,reject)=>{
                try{
                    const prms=[Themify.loadJs(Themify.url+'js/admin/notification',!!win.TF_Notification),Themify.loadJs(Themify.url+'js/admin/jszip.min',!!win.JSZip,'3.10.1')],
                        isTheme=type==='tbp_theme';
                    if(isTheme){
                        prms.push(this.getData(ids[0],vars));
                    }
                    const res=await Promise.all(prms),
                        resp=res[2];
                        
                    if(isTheme && (!resp || !resp.success)){console.log(res);
                        throw 'Error';
                    }
                       
                    let result,
                        postTitle,
                        GS=[],
                        CF=[];
                    const _export=id=>{
                            return new Promise((resolve,reject)=>{
                                setTimeout(()=>{
                                    this.getData(id,vars).then(resolve).catch(reject);
                                },500);
                            });
                        },
                        getTemplates=async templates=>{
                            const ids=Object.keys(templates),
                                msg=vars.export_templates.replaceAll('%to%',ids.length),
                                templatesArr=[];
                            let index=1;
                            for (let id of ids) {
                                let r;
                                await TF_Notification.show('info',msg.replaceAll('%from%',index).replaceAll('%post%',templates[id]));
                                try{
                                    r=await _export(id);
                                }
                                catch(e){
                                    try{
                                        r=await _export(id);//try again
                                    }
                                    catch(e){

                                    }
                                }
                                finally{
                                    if(r){
                                        r=r.data;
                                        if(r.gs){
                                            GS.push(r.gs);
                                            delete r.gs;
                                        }
                                        if(r.cf){
                                            CF.push(r.cf);
                                            delete r.cf;
                                        }
                                        templatesArr.push(r);
                                    }
                                    ++index;
                                }
                            }
                            return templatesArr;
                        };
                    if(isTheme){//is theme export
                        const data=resp.data;
                        postTitle=data.title;
                        await TF_Notification.show('info',vars.export_theme_name.replaceAll('%post%',postTitle));
                        const templates=data.templates?await getTemplates(data.templates):[];
                        result={
                            content:[{
                                title:postTitle,
                                screenshot:data.tbp_theme_screenshot || '',
                                templates:templates
                            }]
                        };
                        
                        postTitle='pro_theme_'+postTitle;
                    }
                    else{
                        const templates=await getTemplates(ids);
                        result={
                            content:templates,
                            import:'template'
                        };
                        postTitle='pro_template_'+templates[0].tbp_template_name;
                    }
                    postTitle=postTitle.replaceAll(' –','-').replaceAll('- ','-').replaceAll('-','_').replaceAll(' ','_');
                    const zip = new JSZip(),
                    date=new Date(),
                    currentData=date.getFullYear()+'_'+date.getMonth()+'_'+date.getDate(),
                    donwload=(blob,name)=>{
                        let a=document.createElement('a');
                        a.download = name;
                        a.rel = 'noopener';
                        a.href = URL.createObjectURL(blob);
                        setTimeout( ()=> { 
                            URL.revokeObjectURL(a.href); 
                            a=null;
                        }, 12000); 
                        a.click();
                    };
                    result = JSON.stringify(result);
                    zip.file('export_file.txt', result);
                    if(GS.length>0){
                        GS=JSON.stringify(GS);
                        zip.file('builder_gs_data_export.txt', GS);
                    }
                    else{
                        GS=null;
                    }
                    if(CF.length>0){
                        CF=JSON.stringify(CF);
                        zip.file('custom-fonts.txt', CF);
                    }
                    else{
                        CF=null;
                    }
                    try{
                        const blob=await zip.generateAsync({type:'blob'}),
                            zipName=postTitle+'_'+currentData+ '.zip';
                        donwload(blob,zipName);
                    }
                    catch(e){
                        try{
                            donwload(new Blob([result], {type: 'application/json'}),postTitle+'_export_file_'+currentData+'.txt');
                            if(GS){
                                donwload(new Blob([GS], {type: 'application/json'}),postTitle+'_builder_gs_data_export_'+currentData+'.txt');
                            }
                            if(CF){
                                donwload(new Blob([CF], {type: 'application/json'}),postTitle+'_custom-fonts_'+currentData+'.txt');
                            }
                        }
                        catch(e){
                            reject(e);
                        }
                    }
                    resolve();
                }
                catch(e){console.log(e);
                    reject(e);
                }
            });
        }
    };
    
})(Themify,window);