let TBP_ImportFromFile;
((Themify,win,und)=> {
    'use strict';
    
    TBP_ImportFromFile={
        async read(file,messages){
            if(file.type==='text/plain'){
                const reader = new FileReader();
                reader.tfOn('loadend',function(e){
                    if(this.readyState===FileReader.DONE){
                        resolve(e.target.result);
                    }
                },{passive:true,once:true})
                .readAsText(file);
            }
            else if(file.type==='application/x-zip-compressed' || file.type==='application/zip'){
                await Themify.loadJs('https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',!!win.JSZip,false);
                const jsZip = new JSZip(),
                zip=await jsZip.loadAsync(file),
                files=zip.files;
                if(files){
                    const builderFileName='export_file.txt',
                           gsFileName='builder_gs_data_export.txt',
                           cfFileName='custom-fonts.txt';
                    if(files[builderFileName]!==und){
                        const prm=[];
                        prm.push(zip.file(files[builderFileName].name).async('text'));
                        if(files[gsFileName]!==und){
                            prm.push(zip.file(files[gsFileName].name).async('text'));
                        }
                        if(files[cfFileName]!==und){
                            prm.push(zip.file(files[cfFileName].name).async('text'));
                        }
                        return Promise.all(prm);
                    }
                    else{
                        throw messages.importBuilderNotExist;
                    }
                }
                else{
                    throw messages.zipFileEmpty;
                }
            }
            else{
                throw messages.importWrongFormat;
            }
        },
        async init(file,self,vars){
                const preventReload=e=>{
                    e.preventDefault();
                    return e.returnValue='Are you sure';
                };
                win.top.tfOn('beforeunload',preventReload);
                try{
                    await Themify.loadJs(Themify.url+'js/admin/notification',!!win.TF_Notification);
                    let [data,gsData,cfFonts]=await this.read(file,vars);
                    data=JSON.parse(data);
                    if(data.content){
                        if(gsData){
                            gsData=JSON.parse(gsData);
                        }
                        data=data.content;
                        const templates=data[0].templates || data;
                        let res;
                        if(data[0].theme_info || data[0].title){//is theme import
                            await TF_Notification.show('info',vars.import_theme_name.replaceAll('%post%',data[0].title));
                            res=await Themify.fetch({
                                is_draft: 1,
                                action:'tbp_theme_saving',
                                nonce: vars.nonce,
                                data: {
                                    tbp_theme_name:data[0].title,
                                    tbp_theme_screenshot:(data[0].theme_info && data[0].theme_info.tbp_theme_screenshot)?data[0].theme_info.tbp_theme_screenshot:(data[0].screenshot || '')
                                }
                            });

                            if(!res.success){
                                throw res.data;
                            }
                            res=res.data;
                            res.title=data[0].title;
                        }
                        else if(!data[0].tbp_template_type){//isn`t template import
                            throw vars.importBuilderNotExist;
                        }
                        else if(!vars.active){//no active theme
                            throw vars.no_active;
                        }
                        
                        if(templates){
                            if(gsData){
                                await TF_Notification.show('info',vars.import_gs_data);
                                try{
                                    await Themify.fetch({
                                        action:'tb_import_gs_posts_ajax',
                                        data: gsData,
                                        nonce: vars.nonce
                                    });
                                }
                                catch(e){
                                    try{
                                        await Themify.fetch({
                                            action:'tb_import_gs_posts_ajax',
                                            data: new Blob( [JSON.stringify(gsData)], { type: 'application/json' }),
                                            nonce: vars.nonce
                                        });
                                    }
                                    catch(e){
                                        
                                    }
                                }
                            }
                            if(cfFonts){

                            }
                            await self.importTemplate((res?res.id:vars.active),templates,'file_templates');
                        }
                        return res;
                    }
                    else{
                        throw vars.importBuilderNotExist;
                    }
                }
                catch(e){
                    throw e;
                }
                finally{
                    win.top.tfOff('beforeunload',preventReload);
                }
        }
    };
    
})(Themify,window,undefined);