let TBP_Predesigned;
((doc, Themify)=> {
    'use strict';
    const observer=new IntersectionObserver((entries, _self)=>{
            for (let i = entries.length - 1; i > -1; --i) {
                if (entries[i].isIntersecting === true) {
                    _self.unobserve(entries[i].target);
                    let el=entries[i].target,
                        imgPlaceholder=el.tfTag('img')[0],
                        src=imgPlaceholder.dataset.src,
                        thumb = new Image(imgPlaceholder.getAttribute('width'),imgPlaceholder.getAttribute('height')),
                        loader = doc.createElement('div');
                        loader.className = 'tf_loader tf_abs_c';
                        thumb.decoding = 'async';
                        thumb.src = src;
                        thumb.title = thumb.alt = imgPlaceholder.alt;
                        el.appendChild(loader);
                        thumb.decode()
                        .finally(() => {
                            imgPlaceholder.replaceWith(thumb);
                            loader.remove();
                        });
                }
            }
                    
        }, {
            threshold: .1
        }),
        cache=new Map(),
        getIcon=ic=>{
            const ns = 'http://www.w3.org/2000/svg',
                use = doc.createElementNS(ns, 'use'),
                svg = doc.createElementNS(ns, 'svg');
                
            ic = 'tf-' + ic.trim().replace(' ', '-');
            svg.setAttribute('class', 'tf_fa ' + ic);
            use.setAttributeNS(null, 'href', '#' + ic);
            svg.appendChild(use);
            return svg;  
        },
        _CLICK_=Themify.click;
    TBP_Predesigned={
        themeUrl:'https://themify.org/builder-pro-themes/wp-json/wp/v2/',
        demoUrl:'https://themify.org/public-api/builder-pro-demos/pro-',
        getHtml(data,type,vars){
            const container=doc.createElement('ul'),
                fr=doc.createDocumentFragment(),
                icon = getIcon('ti-search'),
                webp=doc.createElement('canvas').toDataURL('image/webp').indexOf('data:image/webp') !== -1,
                ext = webp ? 'webp' : 'png';
            let imgW=256,
                imgH=297;
            if(type==='header' || type==='footer'){
                imgW=440;
                imgH=50;
            }
            else if(type==='theme'){
                imgW=262;
                imgH=196;
            }
            const placeholder = '//via.placeholder.com/' + imgW + 'x' + imgH + '.' + ext + '?text=';
                if (data[0].slug !== 'blank') {
                    data.unshift({slug: 'blank',  title: {rendered: vars.blank}});
                }
                for (let i = 0, len = data.length; i < len; ++i) {
                    let li = doc.createElement('li'),
                        title = doc.createElement('span'),
                        itemTitle=data[i].title.rendered,
                        thumbnail = doc.createElement('div'),
                        imgPlaceHolder = new Image(imgW,imgH),
                        src=data[i]['tbp_image_full'] || vars.ph_image;
                    li.dataset.slug = data[i].slug;
                    if(data[i].slug==='blank'){
                        li.className = 'blank selected';
                    }
                    thumbnail.className = 'thumb tf_rel';
                    imgPlaceHolder.loading = 'lazy';
                    imgPlaceHolder.decoding = 'async';
                    imgPlaceHolder.src = data[i].slug==='blank'?(Themify.builder_url+'img/blank-layout.'+ext):(placeholder + encodeURI(itemTitle));
                    imgPlaceHolder.alt = imgPlaceHolder.title = itemTitle;

                    if (src) {
                        imgPlaceHolder.dataset.src=src;
                        observer.observe(thumbnail);
                    }
                    title.className = 'title';
                    title.innerHTML = itemTitle;
                    if (type==='theme' && data[i].link && data[i].link !== '#' ) {
                        let link=doc.createElement('a'),
                            preview=doc.createElement('a');
                        // for Theme demos
                        preview.href =link.href = 'https://themify.org/pro-' + data[i].slug;
                        preview.target = link.target = '_blank';
                        preview.className = 'link tf_box';
                        preview.title = vars.preview;
                        preview.appendChild(icon.cloneNode(true));
                        thumbnail.appendChild(preview);
                        
                        link.appendChild(title);
                        link.className=title.className;
                        title.className='';
                        title=link;
                    }
                    thumbnail.appendChild(imgPlaceHolder);
                    li.append(thumbnail, title);
                    if (type==='theme' && data[i].slug!=='blank') {
                        let importtick = doc.createElement( 'input' ),
                            importWarning = doc.createElement( 'span' ),
                            importlbl = doc.createElement( 'label' );
                        importtick.type = 'checkbox';
                        importlbl.className = 'import_demo tf_rel tf_hide';
                        importWarning.className='tf_box tf_hide';
                        importWarning.appendChild( doc.createTextNode( vars.import_warning ) );
                        importlbl.append( importtick,doc.createTextNode( vars.import_demo ),importWarning );
                        li.appendChild( importlbl );
                    }
                    fr.appendChild(li);
                }
                container.className = 'predesigned predesigned_'+type+' tf_textc';
                container.tfOn(_CLICK_,e=>{
                    const target=e.target?e.target.closest('[data-slug]'):null;
                    if(target){
                        e.stopPropagation();
                        const items=target.parentNode.children;
                        for(let i=items.length-1;i>-1;--i){
                            items[i].classList.toggle('selected',items[i]===target);
                        }
                    }
                },{passive:true})
                .appendChild(fr);
                return container;
                
        },
        async get(url){
            let res=cache.get(url);
            if(!res){
                res=await Themify.fetch('', null, {
                    credentials: 'omit',
                    method: 'GET',
                    mode: 'cors',
                    headers: {
                        'Content-Type': 'application/json'
                    }
                }, url);
                cache.set(url,res);
            }
            return res;
        },
        getThemes(){
            return this.get(this.themeUrl+'tbp_theme');
        },
        getTemplates(type){
            return this.get(this.themeUrl+'tbp_template?template_type='+type);
        },
        getTemplate(slug){
            return this.get(this.themeUrl+'tbp_template?slug='+slug);
        },
        getTheme(slug){
            return this.get(this.demoUrl+ slug + '-templates-new.json');
        },
        getThemeDemo(slug){
            return this.get(this.demoUrl+slug + '-new.json');
        }
    };
})(document, Themify);