((api,  Themify, doc,win,vars,und) => {
    'use strict';
    const src=new URL(doc.currentScript.src,win.location.origin),
        VER=src.searchParams.get('ver'),
        tmp = src.href.split('?')[0].split('/').slice(0,-2),
        _URL=tmp.join('/')+'/',
        cssUrl=_URL+'css/tbp-active',
        init = () => {
        if (vars.template) {
            doc.body.className += ' tbp_template_type_' + vars.template;
            Themify.on('themify_builder_ready', () => {
                setTimeout(() => {
                    win.top.document.body.className += ' tbp_template_type_' + vars.template;
                }, 1000);
            }, true,api.is_builder_ready)
			.on('tb_toolbar_style_ready', ()=>{
				const toolbar = api.ToolBar.el.tfClass('menu')[0],
					cl=api.mode==='visual'?'zoom_menu':'breakpoint_switcher',
					zoom=toolbar.tfClass(cl)[0],
					divider=toolbar.tfClass('divider')[0].cloneNode(true),
					li=doc.createElement('li'),
					btn=doc.createElement('button'),
					tooltip=doc.createElement('span');
				if(zoom){
					tooltip.textContent='Template Options';
					btn.className='tb_tooltip tbp_lightbox_edit';
					btn.append(api.Helper.getIcon('ti-settings'),tooltip);
					li.appendChild(btn);
					btn.tfOn(Themify.click,e=>{
						api.Spinner.showLoader();
						btn.dataset.postId=api.Builder.get(0).id;
						Promise.all([win.top.Themify.loadCss(_URL+'css/modules/top-admin','tbp_top_admin-css',VER),Themify.loadJs(_URL+'js/tbp-admin',null,VER)])
						.then(()=>{
							Themify.triggerEvent(doc,'tbp_edit',btn);
						})
						.finally(()=>{
							api.Spinner.showLoader('spinhide');
						});
						
					},{passive:true});
					if(api.mode==='visual'){
						zoom.after(divider,li);
					}
					else{
						zoom.before(li,divider);
					}
				}
				
			},true,!!(api.ToolBar!==und && api.ToolBar.el!==null));
        }
        ThemifyConstructor.advanced_products_query = {
            render(data, self) {
                if (self.values.query_type) {
                    if (self.values.query_type === 'tag') {
                        self.values.query_type = 'product_tag';
                        self.values.product_tag_terms = self.values.tag_products;
                    } else if (self.values.query_type === 'category') {
                        self.values.query_type = 'product_cat';
                        self.values.product_cat_terms = self.values.category_products;
                    }
                }
                self.values.post_type = 'product';
                return self.create([{
                        type: 'query_posts',
                        id: 'post_type',
                        tax_id: 'query_type',
                        term_id: '#tmp_id#_terms',
                        query_filter: true,
                        slug_id: 'slug'
                    }]);
            }
        };
        ThemifyConstructor.tbp_advanched_layout = {
            render(data, self) {
                const f = doc.createDocumentFragment();
                if (api.mode === 'visual') {
                    const a = doc.createElement('a'),
                            run = e=> {
                                e.stopPropagation();
                                e.preventDefault();
                                api.activeModel.editLayoutPart();
                            };
                    a.className = 'tbp_advanched_archive_edit';
                    a.href = '#';
                    a.tfOn(Themify.click, run, {once: true}).textContent = vars.edit;
                    f.appendChild(a);
                } else {
                    const div = doc.createElement('div');
                    div.classList.add('themify-info-link');
                    div.innerText = vars.edit_backend;
                    f.appendChild(div);
                }
                if (self.values[data.id]) {
                    self.values[data.id] = JSON.stringify(self.values[data.id]);
                }
                f.appendChild(self.hidden.render(data, self));
                return f;
            }
        };
        ThemifyConstructor.fallback = {
            render(data, self) {
                const opt = [
                    {
                        id: 'fallback_s',
                        type: 'toggle_switch',
                        label: 'fall_b',
                        options: {
                            on: {name: 'yes', value: 'en'},
                            off: {name: 'no', value: 'dis'}
                        },
                        binding: {
                            checked: {
                                show: 'fallback_i'
                            },
                            not_checked: {
                                hide: 'fallback_i'
                            }
                        }
                    },
                    {
                        id: 'fallback_i',
                        type: 'image',
                        label: ''
                    }];
                return self.create(opt);
            }
        };

		ThemifyConstructor.info_box = {
            render(data, self) {
				const el = doc.createElement( 'div' );
				el.className = 'themify-info-link';
				el.innerHTML = data.content;
				return el;
			}
		}

        const hasStaticQuery=mod_name =>{
            return !((mod_name === 'advanced-posts' && vars.template === 'archive')
                    || (mod_name === 'advanced-products' && vars.template === 'product_archive'));
        };
        if (api.mode === 'visual') {
            if (vars.id !== und) {
                Themify.on('tb_filter_fetch',ajaxData=>{
                    if(ajaxData.action==='tb_render_element' || ajaxData.action==='tb_load_module_partial'){
                        ajaxData.pageId= vars.id;
                        ajaxData.type = vars.type;
                    }
                });
            }
            Themify.on('tb_layout_edit',()=>{
                
                const AdvanchedEdit=class extends api.LayoutPart{
                    constructor(id) {
                        super(id);
                    }
                    addClass(add){
                       const name=this.model.get('mod_name'),
                            c = name.indexOf('product') !== -1 ? '_product' : '',
                            arhiveCL = 'tbp_edit' + c + '_archive',
                            singleCL = 'tbp_edit' + c + '_single',
                            cl=[doc.body.classList,win.top.document.body.classList,this.toolbar.classList,api.ToolBar.el.classList,api.MainPanel.el.classList,api.SmallPanel.el.classList];
                            for(let i=cl.length-1;i>-1;--i){
                                if(add===true){
                                    cl[i].add('tbp_app_is_edit','tbp_module_'+name,singleCL);
                                }
                                else{
                                    cl[i].remove('tbp_app_is_edit','tbp_module_'+name,singleCL);
                                }
                                cl[i].toggle(arhiveCL,!add);
                            }
                    }
                    edit() {
                        this.model = api.Registry.get(this.id);
                        const el=this.model.el;
                        /* if AAP is using Slider layout, disable the slider before editing */
                        for(let slider=el.querySelectorAll('.builder-posts-wrap > .themify_builder_slider'),i=slider.length-1;i>-1;--i){
                            if (typeof slider[i].swiper === 'object') {
                                slider[i].swiper.destroy();
                                slider[i].parentNode.appendChild(slider[i].tfClass('post')[0]);
                                slider[i].remove();
                            }
                        }
                        const wrap = el.tfClass('tbp_advanced_archive_wrap')[0],
                            elId = this.model.id,
                            getPostId=el=>{
                                let postId;
                                if(el){
                                    postId=el.id;
                                    if(!postId){
                                        const cl=el.classList;
                                        for(let i=cl.length-1;i>-1;--i){
                                            if(cl[i].indexOf('post-')===0){
                                                postId=cl[i];
                                                break;
                                            }
                                        }
                                    }
                                    if(postId){
                                        postId=postId.replace('post-','');
                                        if(isNaN(postId)){
                                            postId=null;
                                        }
                                    }
                                }
                                return postId;
                            },
                            postId=getPostId(wrap.closest('.post')),
                            vals = api.Helper.cloneObject(this.model.get('mod_settings')),
                            filterFetch=ajaxData=>{
                                if(ajaxData.action==='tb_render_element' || ajaxData.action==='tb_load_module_partial'  || ajaxData.action==='tpb_get_dynamic_content_preview'){
                                    const args = ['order', 'orderby', 'offset', 'meta_key'];
                                    ajaxData.aap=true;
                                    if(postId){
                                        ajaxData.tbp_post_id=postId;
                                    }
                                    if (hasStaticQuery(this.model.get('mod_name')) === true) {
                                        args.push('terms');
                                        args.push('term_type');
                                        args.push('tax');
                                        args.push('post_type');
                                    }
                                    for (let i = args.length - 1; i > -1; --i) {
                                        if (vals[args[i]] !== und && vals[args[i]] !== '') {
                                            let type=args[i]==='tax'?'tax':args[i];
                                            ajaxData[type] = vals[args[i]];
                                        }
                                    }
                                }
                            };
                        let data = vals.builder_content;
                        
                        wrap.classList.add('themify_builder', 'themify_builder_content', 'themify_builder_content-' + elId);
                        wrap.dataset.postid=elId;

                        if (typeof data === 'string') {
                            data = JSON.parse(data);
                        }
                        api.LayoutPart.cache[elId] = {builder_data:data};
                        Themify.on('tb_filter_fetch',filterFetch)
                        .on('tb_resotre_layout_part',()=>{
                            Themify.off('tb_filter_fetch',filterFetch);
                        },true);
                        
                        
                        return super.edit().then(()=>{
                            api.Builder.get().post_id=postId;
                            this.addClass(true);
                        });
                    }
                    async save(){
						await api.LightBox.save();
						this.html=null;
						const data = this.model.get('mod_settings');
						data.builder_content = api.Builder.get().toJSON();
						this.model.set('mod_settings',data);
						TF_Notification.showHide('done',vars.aap_saved.replace('%s',this.model.getName()));
						api.Builder.get().isSaved = true;//need to detect if there is changes after closing layout part
						this.isSaved=true;//once it saved always should get the last html after close
                    }
                    async close(){
                        const res=await super.close();
						if(res!==false){
							delete api.LayoutPart.cache[this.model.id];
							this.addClass(false);
							if(this.isSaved===true){
								api.Spinner.showLoader();
								await this.model.trigger('ajax', this.model.get('mod_settings'));
								api.Spinner.showLoader('done');
								this.model=this.isSaved=null;
							}
						}
						else{
							return res;
						}
                    }
                }
                api.AdvancedPosts=api.AdvancedProducts=api.AdvancedProducts=api.PtbRepeater = api.AcfRepeater = AdvanchedEdit;
            },true);
        }

        /* create Dynamic Query toggle field on "query_post" field types */
        Themify.on('tb_editing_module', lb => {
            const onChage = function () {
                const selected = this.value,
                        el = lb.querySelector('.tb_field[data-type="query_posts"]');
                el.style.display = selected === 'off' ? '' : 'none';
                for (let items = lb.tfClass('tbpdq_settings'), i = items.length - 1; i > -1; --i) {
                    items[i].style.display = items[i].classList.contains('tbpdq_settings_' + selected) ? '' : 'none';
                }
            },
            options = Object.assign({}, themifyBuilder.DynamicQuery),
            items = lb.querySelectorAll('.tb_field[data-type="query_posts"]');
            for (let i = items.length - 1; i > -1; --i) {
                if (!items[i].classList.contains('tbp_disable_dynamic_query')) {

                    let opt = ThemifyConstructor.create(options),
                        select = opt.querySelector('#tbpdq');
                    if(select!==null){
                        /* on archive pages, AAP modules show the Main Query by default */
                        if (ThemifyConstructor.values && ThemifyConstructor.values.tbpdq === und && !hasStaticQuery(ThemifyConstructor.type)) {
                            select.value = 'on';
                        }
                        select.tfOn('change', onChage, {passive: true});
                        /* disable the Main Loop option in non-archive pages */
                        if (vars.template !== 'archive' && vars.template !== 'product_archive') {
                            select.querySelector('option[value="on"]').setAttribute('disabled', 'disabled');
                        }
                    }
                    items[i].before(opt);
                    if(select!==null){
						/* in Event Post module, disable the corresponding DQ option, as similar options exist in the module */
						if ( ThemifyConstructor.type === 'event-posts' ) {
							const tep = select.querySelector( 'option[value="tep"]' );
							if ( tep ) {
								tep.style.display = 'none';
							}
						}

                        onChage.call(select);
                    }
                }
            }
        });
        if(vars.template){
            Themify.loadJs(_URL+'js/modules/builder-layout', null, VER);
        }

		/**
		 * Returns the default template for a PTB Repeater based on the PTB field type
		 * Note that __FIELD_NAME__ in the template is replaced with the PTB field's name.
		 *
		 * @return string
		 */
		function ptb_repeater_default_template( field_type ) {
			if ( field_type === 'video' ) {
				return '[{"cols":[{"grid_class":"col-full","modules":[ {"element_id":"lqhd151","elType":"module","mod_name":"video","mod_settings":{"mute_video":"no","__dc__":{"url_video":{"show":"url","field":"__FIELD_NAME__","item":"PTBVideo","o":""},"title_video":{"show":"title","field":"__FIELD_NAME__","item":"PTBVideo"},"caption_video":{"show":"description","field":"__FIELD_NAME__","item":"PTBVideo"}},"title_tag":"h3","unit_video":"px","loop":"no","autoplay_video":"no","ext_branding":"no","ext_hide_ctrls":"no","style_video":"video-top"},"component_name":"module"} ]}]}]';
			} else if ( field_type === 'audio' ) {
				return '[{"cols":[{"grid_class":"col-full","modules":[ {"element_id":"gvac426","elType":"module","mod_name":"text","mod_settings":{"__dc__":{"mod_title_text":{"show":"title","field":"__FIELD_NAME__","item":"PTBAudio"},"content_text":{"show":"url","field":"__FIELD_NAME__","item":"PTBAudio","o":""}}},"component_name":"module"}, {"element_id":"eqq2487","elType":"module","mod_name":"text","mod_settings":{"__dc__":{"content_text":{"show":"description","field":"__FIELD_NAME__","item":"PTBAudio","o":""}},"margin_bottom":"20"},"component_name":"module"} ]}]}]';
			} else if ( field_type === 'file' ) {
				return '[{"cols":[{"grid_class":"col-full","modules":[ {"element_id":"5tj7724","elType":"module","mod_name":"buttons","mod_settings":{"content_button":[{"label":"","link":"","link_options":"regular","button_color_bg":"orange","icon":"ti-save-alt","icon_alignment":"left"}],"__dc__":{"content_button":{"0":{"label":{"show":"title","field":"__FIELD_NAME__","item":"PTBFile","o":""},"link":{"show":"url","field":"__FIELD_NAME__","uri_scheme":"0","item":"PTBFile","o":""}},"repeatable":1}},"download_link":"yes","display":"buttons-horizontal","buttons_shape":"normal","buttons_size":"normal","disp":"inline-block"},"component_name":"module"} ]}]}]';
			} else if ( field_type === 'slider' || field_type === 'gallery' ) {
				return '[{"cols":[{"grid_class":"col-full","modules":[ {"element_id":"wznk445","elType":"module","mod_name":"image","mod_settings":{"__dc__":{"url_image":{"show":"url","field":"__FIELD_NAME__","item":"PTBGalleryAsText"},"title_image":{"show":"title","field":"__FIELD_NAME__","item":"PTBGalleryAsText"},"link_image":{"show":"link","field":"__FIELD_NAME__","uri_scheme":"0","item":"PTBGalleryAsText"},"caption_image":{"show":"description","field":"__FIELD_NAME__","item":"PTBGalleryAsText"}},"image_zoom_icon":false,"title_tag":"h3","auto_fullwidth":false,"appearance_image":false,"caption_on_overlay":false,"style_image":"image-top"},"component_name":"module"} ]}]}]';
			} else if ( field_type === 'accordion' ) {
				return '[{"cols":[{"grid_class":"col-full","modules":[ {"element_id":"gnii791","elType":"module","mod_name":"accordion","mod_settings":{"content_accordion":[{"title_accordion":"","text_accordion":"","default_accordion":"closed"}],"__dc__":{"content_accordion":{"0":{"title_accordion":{"show":"title","field":"__FIELD_NAME__","item":"PTBAcc","o":""},"text_accordion":{"show":"body","field":"__FIELD_NAME__","item":"PTBAcc","o":""}},"repeatable":1}},"hashtag":"no","expand_collapse_accordion":"toggle","margin_bottom":"0"},"component_name":"module"} ]}]}]';
			}
		}

		/**
		 * PTB Repeater module, add default template and fix live preview
		 */
		Themify.on( 'tb_editing_ptb-repeater_setting', lb=>{
			lb.querySelector( '#key' ).tfOn( 'change', function() {
				const type = this.value.split(':')[2],
					template_field = lb.querySelector( '#builder_content' ),
					template = ptb_repeater_default_template( type ).replaceAll( '__FIELD_NAME__', this.value );
				template_field.value = template;
				if ( api.mode === 'visual' ) {
					/* update the values for live preview */
					ThemifyConstructor.settings.key = this.value;
					ThemifyConstructor.settings.builder_content = template;
					/* trigger live preview update */
					Themify.triggerEvent( lb.querySelector( '#display input:checked' ), 'change' );
				}
			} ,{passive:true});
		} );

    };
    
    Themify.loadCss(cssUrl, null, VER);
    if (api.mode === 'visual') {
        win.top.Themify.loadCss(cssUrl, null, VER);
    }

    api.jsModuleLoaded().then(init);
})(tb_app, Themify, document,window,tbp_local,undefined);
