(($,Themify,api,doc,args,und)=>{
    'use strict';

    let DC = {},
            DynamicCache = null,
            hidden;

    const EXCLUDE=[
			'item_title_field',
			'placeholder',
			'button_t',
			'custom_url',
			'fallback_i',
			'prev_label',
			'next_label',
			'cat',
			'tag',
			'sku',
			'sep'
        ],
        CacheRequest = new Map(),
        fieldName = args.field_name,
        getData = async ()=> {
                if(DynamicCache===null){
                    const name = 'tbp_dc',
                        key = Themify.hash(args.v + Object.keys(args.items));
                    if (!themifyBuilder.debug) {
                        try {
                            let result = localStorage.getItem(name);
                            if (result) {
                                result = JSON.parse(result);
                                if (result.h === key && result.v) {
                                    DynamicCache= result.v;
                                }
                            }
                        } 
                        catch (e) {
                        }
                    }
                    if (DynamicCache === null) {
                        DynamicCache=await api.LocalFetch({
                            action: 'tpb_get_dynamic_content_fields'
                        });
                        try {
                            Themify.requestIdleCallback(()=>{
                               localStorage.setItem(name, JSON.stringify({v: DynamicCache, h: key}));
                            },-1,3000);
                        } 
                        catch (e) {
                        }
                    }
                }
            },
            getPreviewVal = async vals=> {
                // get preview
                let after = '',
                        before = '',
                        req;
                if (typeof vals !== 'string') {
                    if (!vals || vals.item === und) {
                        return;
                    }
                    req = api.Helper.cloneObject(vals);
                    after = req.text_after,
                    before = req.text_before;
                    delete req.text_before;
                    delete req.text_after;
                    delete req.o;
                    req = JSON.stringify(req);
                } else {
                    req = vals;
                }
                const builder=api.Builder.get(),
                    post_id=builder.post_id || builder.id,
                    key = Themify.hash(req + post_id);
                    
                let data=CacheRequest.get(key);
                if (!data) {
                    data =await api.LocalFetch({
                            action: 'tpb_get_dynamic_content_preview',
                            tbp_post_id: post_id,
                            values: req
                    });
                    data=(data.error ? data.error : (data.value === '' || data.value === 'false' ? null : data.value));
                    CacheRequest.set(key,data);
                }
                if (before !== und || after !== und) {
                    if (!data) {
                        data = '';
                    }
                    if (before !== und) {
                        data = before + data;
                    }
                    if (after !== und) {
                        data += after;
                    }
                }
                return data;
            },
            createOptions =  (type, values)=> {
                const oldVals = ThemifyConstructor.values,
                        options_wrap = doc.createElement('div'),
                        Options = Object.values(api.Helper.cloneObject(DynamicCache)),
                        dynamic = args.items;
                options_wrap.className = 'tbp_dynamic_content_options tf_box tf_hide';
                for (let i = Options.length - 1; i > -1; --i) {
                    if (Options[i].id === 'item') {
                        let group = Options[i].options;
                        for (let j in group) {
                            for (let k in group[j].options) {
                                if (dynamic[ k ] !== und && dynamic[ k ].type.indexOf(type) === -1) {
                                    delete group[j].options[k];
                                }
                            }
                            if (Object.keys(group[j].options).length === 0) {
                                delete group[j];
                            }
                        }
                        break;
                    }
                }
                if (values === und) {
                    values = {};
                }
                ThemifyConstructor.values = values;
                const form = ThemifyConstructor.create(Options),
                        opt = form.querySelectorAll('.tb_lb_option,.tb_lb_option_child');
                // prevent Builder from saving these fields individually
                for (let i = opt.length - 1; i > -1; --i) {
                    opt[i].classList.remove('tb_lb_option', 'tb_lb_option_child');
                }
                ThemifyConstructor.values = oldVals;
                options_wrap.appendChild(form);
                return options_wrap;
            },
            /* enable or disable validation rules for a field */
            toggle_validation_rules = (field, state) =>{
                field =  field.closest('.tb_field');
                if (!state && field.classList.contains('tb_must_validate')) {
                    /* disable validation rules */
                    field.classList.remove('tb_must_validate');
                    field.dataset.had_validation_rules = true;
                } else if (state && field.dataset.had_validation_rules) {
                    /* re-enable validation rules */
                    field.classList.add('tb_must_validate');
                    delete field.dataset.had_validation_rules;
                }
            },
            EnableDc = async(el, init) =>{
                let field = el.parentNode.closest('.tb_field'),
                        pid = getRepeatId(field),
                        type = getType(field),
                        parent = field.tfClass('tb_input')[0],
                        values = {};
                if (parent !== und && parent.parentNode.classList.contains('tb_has_dc')) {
                    field = parent;
                    parent = null;
                }
                const id = getId(field, type);
                if (pid !== null) {
                    if (DC[pid] !== und) {
                        const index = getRepeatIndex(field);
                        if (DC[pid][index] !== und) {
                            values = DC[pid][index];
                        }
                    }
                } else {
                    values = DC;
                }
                if (init === true) {
                    if (values[id] !== und) {
                        el.checked = true;
                    } else {
                        return;
                    }
                }
                if (el.checked === true) {
                    field.classList.add('tbp_dc_active');
                    toggle_validation_rules(field, false);

                    let placeholder = field.tfClass('tbp_dc_input')[0];
                    if (placeholder === und) {
                        await getData();
                        const  wrap = doc.createElement('div');
                        placeholder = doc.createElement('input');
                        wrap.className = 'tbp_dc_wrap tf_hide';
                        placeholder.className = 'tbp_dc_input';
                        placeholder.type = 'text';
                        placeholder.setAttribute('readonly', true);
                        const onTypeChange = async el=> {
                            const dcWrap = el.closest('.tbp_dc_wrap'),
                                    itemType = dcWrap.querySelector('#item'),
                                    v = itemType.value,
                                    items = itemType.closest('.tb_field').nextElementSibling.children,
                                    cl = 'field_' + v,
                                    generalCl = 'field_general_' + type;
                            let blocks = [];
                            placeholder.value = itemType.options[itemType.selectedIndex].text;
                            blocks.push(itemType.parentNode);
                            for (let i = items.length - 1; i > -1; --i) {
                                if (v !== '' && (
                                        items[i].classList.contains(cl)
                                        || items[i].classList.contains(generalCl) // display general options based on the field type in Builder
                                        || (v.substring(0, 3) === 'ACF' && items[i].classList.contains('tbp_dynamic_content_acf_ctx')) // options for Advanced Custom Fields plugin
                                        )) {
                                    items[i].style.display = 'block';
                                    blocks.push(items[i]);
                                } else {
                                    items[i].style.display = '';
                                }
                            }

                            ThemifyConstructor.callbacks();
                            if (!v) {
                                blocks = null;
                            }
                            const vals = update_value(id, blocks, dcWrap);
                            let res = await getPreviewVal( vals );
                            blocks = null;
                             /* fallback value in preview */
                            if (null === res) {
                                res = type === 'image' ? args.placeholder_image : '{' + vals.item + '}';
                            }

                            const item = getField(itemType, id);
                            if (item !== null) {
                                item.value = res;
                                let obj = null;
                                if (type === 'wp_editor') {
                                    obj = tinymce.get(item.id);
                                    if (obj) {
                                        obj.setContent(String(res));
                                        obj.fire('change');
                                    }
                                }
                                if (!obj) {
                                    Themify.triggerEvent(item, 'change');
                                    if (type !== 'image' && item.nodeName !== 'SELECT') {
                                        Themify.triggerEvent(item, 'keyup');
                                    }
                                }
                            }
                        };
                        placeholder.tfOn('click', function (e) {
                            e.preventDefault();
                            e.stopImmediatePropagation();
                            let options_wrap = this.nextElementSibling;
                            if (options_wrap === null) {
                                options_wrap = createOptions(type, values[id]);
                                $(options_wrap).on('change.dc_preview', ':input', function (e) {
                                    e.stopPropagation();
                                    onTypeChange(e.target);
                                });
                                this.parentNode.appendChild(options_wrap);
                            }
                            const isVisible = options_wrap.style.display !== 'block',
                                    Optitems = api.LightBox.el.tfClass('tbp_dynamic_content_options');
                            for (let i = Optitems.length - 1; i > -1; --i) {
                                Optitems[i].style.display = '';
                            }
                            if (isVisible === true) {
                                const Click = function (e) {
                                    if (e.target.closest('.tbp_dc_wrap') === null) {
                                        doc.tfOff(e.type, Click, {passive: true});
                                        if (api.mode === 'visual') {
                                            window.top.document.tfOff(e.type, Click, {passive: true});
                                        }
                                        options_wrap.style.display = '';
                                    }
                                    if (api.mode === 'visual') {
                                        $(doc).triggerHandler('mouseup');
                                    }
                                };
                                doc.tfOn('pointerdown', Click, {passive: true});
                                if (api.mode === 'visual') {
                                    window.top.document.tfOn('pointerdown', Click, {passive: true});
                                }
                                onTypeChange(this);
                                options_wrap.style.display = 'block';
                            } else {
                                options_wrap.style.display = '';
                            }
                        });
                        wrap.append(api.Helper.getIcon('ti-pencil'),placeholder);
                        if (values[ id ] !== und) {
                            const value = values[ id ].item,
                                    opt = DynamicCache[0].options;
                            for (let i in opt) {
                                if (opt[i].options[value] !== und) {
                                    placeholder.value = opt[i].options[value];
                                    break
                                }
                            }
                            if (type === 'image' && ThemifyConstructor.clicked === 'styling') {
                                const imgOptions = field.closest('.tb_tab').tfClass('tb_image_options');
                                for (let i = imgOptions.length - 1; i > -1; --i) {
                                    imgOptions[i].classList.remove('_tb_hide_binding');
                                }
                            } else {
                                ThemifyConstructor.callbacks();
                            }
                        }
                        field.appendChild(wrap);
                    if (init === und) {
                        setOrigValue(field, id, type);
                    }
                    }
                    else if (init === und) {
                        setOrigValue(field, id, type);
                        if (values[id] !== und) {
                            placeholder.click();
                        }
                        toggleStylesheet(false);
                    }
                } else if (init === und) {
                    toggle_validation_rules(field, true);
                    revertOrigValue(field, id, type);
                    field.classList.remove('tbp_dc_active');
                    update_value(id, null, field);
                    toggleStylesheet(true);
                }

            },
            getRepeatIndex = el=> {
                return $(el.closest('.tb_repeatable_field')).index();
            },
            getRepeatId = el=>{
                const item = el.parentNode.closest('.tb_row_js_wrapper');
                return item !== null ? item.id : null;
            },
            toggleStylesheet = disable =>{
                if (api.mode === 'visual' && ThemifyConstructor.clicked === 'styling') {
                    const el = api.liveStylingInstance.el.closest('.tb_active_layout_part') || api.liveStylingInstance.el,
                        styles = el.tfClass('tbp_dc_styles');
                    for (let i = styles.length - 1; i > -1; --i) {
                        styles[i].sheet.disabled = disable;
                    }
                }
            },
            getId = (el, type)=> {
                const cl = type === 'image' ? 'tb_uploader_input' : (el.parentNode.closest('.tb_repeatable_field_content') !== null ? 'tb_lb_option_child' : 'tb_lb_option'),
                        item = el.tfClass(cl)[0];
                let id;
                if (item !== und) {
                    id = item.dataset.inputId;
                }
                if (!id) {
                    id = item.id;
                }
                return id.trim();
            },
            update_value =  (key, val, item) =>{
                let dc,
                        index = null,
                        pid = getRepeatId(item);
                if (pid !== null) {
                    index = getRepeatIndex(item);
                }
                if (val === null) {
                    dc = hidden.value;
                    dc = dc ? JSON.parse(dc) : {};
                    if (!dc) {
                        dc = {};
                    }
                    if (index !== null) {
                        let update = false;
                        if (dc[pid] !== und) {
                            if (key === null) {
                                if (dc[pid][index] !== und) {
                                    update = true;
                                    delete DC[pid][index];
                                    delete dc[pid][index];
                                }
                            } else if (dc[pid][index] !== und && dc[pid][index][key] !== und) {
                                update = true;
                                delete dc[pid][index][key];
                                const len = Object.keys(dc[pid][index]).length;
                                if (len === 0 || (len === 1 && dc[pid][index].o !== und)) {
                                    update = true;
                                    delete DC[pid][index];
                                    delete dc[pid][index];
                                }
                            } else {
                                return;
                            }
                            if (Object.keys(dc[pid]).length === 0 || (Object.keys(dc[pid]).length === 1 && dc[pid].repeatable !== und)) {
                                update = true;
                                delete DC[pid];
                                delete dc[pid];
                            }
                        }
                        if (update === false) {
                            return;
                        }
                    } else {
                        if (dc[key] !== und) {
                            delete dc[ key ];
                        } else {
                            return;
                        }
                    }
                } else {
                    let orig;
                    if (index !== null) {
                        if (DC[ pid ] === und) {
                            DC[ pid ] = {};
                        }
                        DC[ pid ].repeatable = 1; // flag for "builder" field type (repetable fields)
                        if (DC[pid][index] === und) {
                            DC[pid][index] = {};
                        }
                        if (DC[pid][index][key] === und) {
                            DC[pid][index][key] = {};
                        }
                        orig = DC[pid][index][key].o !== und ? DC[pid][index][key].o : null;
                    } else {
                        if (DC[ key ] === und) {
                            DC[ key ] = {};
                        }
                        orig = DC[key].o !== und ? DC[key].o : null;
                    }
                    if (Array.isArray(val)) {
                        const values = {};
                        for (let i = val.length - 1; i > -1; --i) {
                            let items = val[i].querySelectorAll('input,textarea,select');
                            for (let j = items.length - 1; j > -1; --j) {
                                let v = items[j].value;
                                if (v !== '' && !items[j].parentNode.parentNode.classList.contains('_tb_hide_binding')) {
                                    values[items[j].id] = v;
                                }
                            }
                        }
                        val = api.Helper.clear(values);
                    }
                    if (index !== null) {
                        DC[pid][index][key] = val;
                        if (orig !== null) {
                            DC[pid][index][key].o = orig;
                        }
                    } else {
                        DC[ key ] = val;
                        if (orig !== null) {
                            DC[ key ].o = orig;
                        }
                    }
                    dc = DC;
                }
                hidden.value = JSON.stringify(dc);
                return val;
            },
            /**
             * Get original field
             *
             * @return dom element
             */
            getField = (field, id)=> {
                let item = field.closest('.tb_repeatable_field_content');
                if (item !== null) {
                    item = item.querySelector('.tb_lb_option_child[data-input-id="' + id + '"]');
                } else {
                    item = api.LightBox.el.querySelector('#' + id);
                }
                return item;
            },
            /**
             * Set value to original field
             *
             * @return mixed
             */
            setOrigValue = (field, id, type)=> {
                let value = null,
                        index = null,
                        _id = id;
                if (type === 'wp_editor') {
                    let obj = tinymce.get(id);
                    if (!obj) {
                        obj = tinymce.get(getField(field, id).id);
                    }
                    if (obj) {
                        value = obj.getContent();
                    }
                } else {
                    const item = getField(field, id);
                    if (item !== null) {
                        value = item.value;
                    }
                }
                const pid = getRepeatId(field);
                if (pid !== null) {
                    index = getRepeatIndex(field);
                    _id = pid;
                }
                if (value !== null && value !== '') {
                    if (DC[_id] === und) {
                        DC[_id] = {};
                    }
                    if (index !== null) {
                        if (DC[_id][index] === und) {
                            DC[_id][index] = {};
                        }
                        if (DC[_id][index][id] === und) {
                            DC[_id][index][id] = {};
                        }
                        DC[_id][index][id].o = value;
                    } else {
                        DC[_id].o = value;
                    }
                } else if (DC[_id] !== und) {
                    if (index !== null) {
                        if (DC[_id][index] !== und && DC[_id][index][id] !== und) {
                            delete DC[_id][index][id].o;
                        }
                    } else {
                        delete DC[_id].o;
                    }
                }
                hidden.value = JSON.stringify(DC);
                return value;
            },
            /**
             * Revert value to original field
             *
             * @return void
             */
            revertOrigValue = (field, id, type)=> {
                let pid = getRepeatId(field),
                        v = '';
                if (pid !== null) {
                    if (DC[pid] !== und) {
                        const index = getRepeatIndex(field);
                        if (DC[pid][index] !== und && DC[pid][index][id] !== und && DC[pid][index][id].o !== und) {
                            v = DC[pid][index][id].o;
                        }
                    }
                } else if (DC[id] !== und && DC[id].o !== und) {
                    v = DC[id].o;
                }
                if (type === 'wp_editor') {
                    let obj = tinymce.get(id);
                    if (!obj) {
                        obj = tinymce.get(getField(field, id).id);
                    }
                    if (obj) {
                        obj.setContent(String(v));
                        obj.fire('change');
                    }
                } else {
                    const item = getField(field, id);
                    if (item !== null) {
                        item.value = v;
                        Themify.triggerEvent(item, 'change');
                        if (type !== 'image' && item.nodeName !== 'SELECT') {
                            Themify.triggerEvent(item, 'keyup');
                        }
                    }
                }
            },
            /**
             * Get a div.tb_field element and returns the element type
             *
             * @return string
             */
            getType = field=> {
                let type = field.dataset.type;
                if (type === 'imageGradient') {
                    /* imageGradient field type is used in Styling, functions similarly as "image" */
                    type = 'image';
                } else if (type === 'title') {
                    /* module title fields, treated as "text" */
                    type = 'text';
                }
                return type;
            },
            /**
             * Get a list of Builder field types that can accept Dynamic Content
             *
             * Compiled from get_type() method of all available Tbp_Dynamic_Item
             *
             * @return array
             */
            getApplicableTypes = ()=> {
                let types = ['title','imageGradient'];
                for(let i in args.items){
                    types=[...types, ...args.items[i].type];
                }
                return [...new Set(types)];
            },
            addSwitch = (container, types = []) =>{
                if (types.length === 0) {
                    types = getApplicableTypes();
                }
                let found = false;
                for (let i = types.length - 1; i > -1; --i) {
                    let items = container.querySelectorAll('.tb_field[data-type="' + types[i] + '"]');
                    for (let j = items.length - 1; j > -1; --j) {
                        if (!items[j].classList.contains('tb_has_dc') && !items[j].classList.contains('tb_disable_dc')) {
                            found = false;
                            /* certain options should not have DC enabled */
                            for (let k = EXCLUDE.length - 1; k > -1; --k) {
                                if (items[j].classList.contains(EXCLUDE[k])) {
                                    found = true;
                                    break;
                                }
                            }
                            if (found === false) {
                                items[j].className += ' tb_has_dc';
                                let label = doc.createElement('label'),
                                        input = doc.createElement('input'),
                                        div = doc.createElement('div');
                                label.className = 'tpb_dc_toggle switch-wrapper tf_hide';
                                input.type = 'checkbox';
                                input.className = 'toggle_switch';
                                div.className = 'switch_label';
                                div.dataset.on=div.dataset.off=args.d_label;
                                input.tfOn('change', function (e) {
                                    e.stopPropagation();
                                    EnableDc(this);
                                }, {passive: true});
                                label.append(input,div);
                                items[j].insertBefore(label, items[j].firstChild);
                                EnableDc(input, true);
                            }
                        }
                    }
            }
            };

    api.jsModuleLoaded().then(()=>{
        Themify.requestIdleCallback( ()=>{
            
            Themify.on('themify_builder_ready', ()=> {
                setTimeout(getData, 2500);
            }, true,api.is_builder_ready);
            
            Themify.on('tb_repeatable_add_new tb_repeatable_duplicate tb_repeatable_delete', function (e) {
                if (e.type === 'tb_repeatable_delete') {
                    update_value(null, null, e.detail[0]);
                } else {
                    addSwitch(e.detail[0]);
                }
            }).on('tb_editing_module tb_editing_row tb_editing_column tb_editing_subrow', function (e) {
                const builder = ThemifyConstructor,
                        container = api.LightBox.el;
                hidden = builder.hidden.render({
                    type: 'hidden',
                    class: 'exclude-from-reset-field',
                    responsive: false,
                    control: false,
                    id: fieldName
                }, builder);
                // save & store previously saved values
                if (builder.values[ fieldName ] !== und) {
                    try {
                        DC = typeof builder.values[ fieldName ] === 'string' ? JSON.parse(builder.values[ fieldName ]) : api.Helper.cloneObject(builder.values[ fieldName ]);
                        hidden.value = JSON.stringify(DC);
                    } catch (e) {
                        DC = {};
                    }
                } else {
                    DC = {};
                }
                container.tfClass('tb_options_tab_wrapper')[0].appendChild(hidden);
                addSwitch(container);
            })
            .on('tb_builder_tabsactive tb_options_expand', function (id, container) {
                if (api.activeModel !== null) {
                    let clicked = ThemifyConstructor.clicked;
                    setTimeout(function () {
                        clicked = ThemifyConstructor.clicked;
                        if (clicked !== 'animation' && clicked !== 'visibility') {
                            if ( container === und ) {
								/* for tb_options_expand event */
                                container = id;
                                id = null;
                            }
                            if (clicked !== 'styling' || id === null || ( id && id.indexOf('_h') === -1 ) ) {
                                // in Styling options, only enable on Background option
                                addSwitch(container, clicked === 'styling' ? ['imageGradient', 'image'] : []);
                            }
                        }
                    }, clicked === 'setting' ? 0 : 50);
                }
            });
            
        }, 15);
    });

})(jQuery,Themify, tb_app,document,tbpDynamic,undefined);
