((Themify,doc,vars,und) =>{
    'use strict';
    
    Themify.on('tbp_ready',TBP=>{
        
        Themify.on('tbp_layout_loaded',TBP=>{
            class Theme  extends TBP{
                constructor(type){
                    super(type);
                }
                getOptions(){
                    const args= [
                        {
                            id:'tbp_theme_name',
                            label: vars.opt_labels.tbp_theme_name,
                            type:'text'
                        }
                    ];
                    if(vars.opt_labels.tbp_theme_screenshot){
                        args.push({
                            id:'tbp_theme_screenshot',
                            label:vars.opt_labels.tbp_theme_screenshot,
                            type:'image',
                            description:vars.opt_labels.tbp_theme_screenshot_desc
                        });
                    }
                    return args;
                }
                async importDemo(themeId,data){
                    const terms=data.terms,
                        posts=data.posts,
                        menu_locations=data.menu_locations,
                        menu=data.menu,
                        menu_items=data.menu_items;
                    if(menu){
                        const menus={menu:menu};
                        if(menu_locations){
                            menus.menu_locations=menu_locations;
                        }
                        await this.import('menu',menus);
                    }
                    if(terms){
                        await this.import('terms',terms);
                    }
                    if(posts){
                        await this.import('posts',posts);
                    }
                    if(menu_items){
                        await this.import('menu_items',menu_items);
                    }
                }
            }
            new Theme('theme');
        
        },true);
        
        
        const ThemeDetail={
            init(){
                doc.tfClass('tbp_themes')[0].tfOn(Themify.click,e=>{
                    const target=e.target.closest('.tb_more_details');
                    if(target){
                        e.stopPropagation();
                        this.details(target.dataset.id);
                    }
                },{passive:true});
                this.overlay=doc.tfClass('theme-overlay')[0];
            },
            details(id){
                id = parseInt(id);
                const tpl = wp.template('tbp-theme-single'),
                    click=Themify.click,
                    themes=vars.themes; 
                let settings=null,
                    next,
                    prev;
                    for(let i=themes.length-1;i>-1;--i){
                        if(themes[i].theme_id===id){
                            settings=themes[i];
                            next = themes[i+1];
                            prev=themes[i-1];
                            break;
                        }
                    }
                    if(settings!==null){
                        settings.next=next!==und;
                        settings.prev=prev!==und;
                        this.overlay.classList.toggle('active',settings.active);
                        this.overlay.innerHTML=tpl(settings);
                        const closeBtn = this.overlay.tfClass('close')[0],
                            left = this.overlay.tfClass('left')[0],
                            right = this.overlay.tfClass('right')[0],
                            deleteBtn = this.overlay.tfClass('delete-theme')[0],
                            editBtn = this.overlay.tfClass('tbp_lightbox_edit')[0],
                            eraseBtn=this.overlay.tfClass('tbp_erase_demo')[0],
                         close = e=>{
                                e.preventDefault();
                                e.stopPropagation();
                                this.overlay.innerHTML='';
                                this.overlay.classList.add('active');
                                removeEvents();
                           },
                           change=function(e){
                                e.preventDefault();
                                e.stopPropagation();
                                if(!this.classList.contains('disabled')){
                                    const nextId = this.classList.contains('left')?prev.theme_id:next.theme_id,
                                        items = doc.tfClass('tb_more_details');
                                    for(let i=items.length-1;i>-1;--i){
                                        if(items[i].dataset.id==nextId){
                                            removeEvents();
                                            Themify.triggerEvent(items[i],click);
                                            break;
                                        }
                                    }

                                }
                           },
                           _delete=function(e){
                                e.stopPropagation();
                                e.preventDefault();
                                if(confirm(vars.confirmDelete)){
                                    window.location.href=this.href;
                                } 
                            },
                            edit=function(e){
                                e.stopPropagation();
                                e.preventDefault();
                                Themify.triggerEvent(doc.querySelector('.tbp_themes .tbp_lightbox_edit[data-post-id="'+this.dataset.postId+'"]'),e.type);
                                close(e);
                            },
                            removeEvents=()=>{
                                left.tfOff(click,change);
                                right.tfOff(click,change);
                                closeBtn.tfOff(click,close,{once:true});
                                if(deleteBtn!==und){
                                    deleteBtn.tfOff(click,_delete);
                                }
                                if(editBtn!==und){
                                    editBtn.tfOff(click,edit);
                                }
                           },
                        erase_demo=async e=>{
                            if(e){
                                e.stopPropagation();
                                e.preventDefault();
                            }
                            await Themify.loadJs(Themify.url+'js/admin/notification',!!window.TF_Notification);
                            await TF_Notification.show('info',vars.erase.processing);
                            try{
                                const resp=await Themify.fetch({
                                    action: 'tbp_ajax_erase_demo',
                                    nonce:vars.nonce
                                });
                                if(!resp.success){
                                    throw 'error';
                                }
                                if(resp.data==='repeat'){
                                    await erase_demo();
                                }
                                else{
                                    await TF_Notification.showHide('done',vars.erase.done,2000);
                                }
                            }
                            catch(e){
                                const er=typeof e==='string'?e:'';
                                await TF_Notification.showHide('error',vars.erase.error.replace('%error%',er),4000);
                                throw e; 
                            }
                        };
                        if(deleteBtn!==und){
                            deleteBtn.tfOn(click,_delete);
                        }
                        if(editBtn!==und){
                            editBtn.tfOn(click,edit);
                        }
                        if(eraseBtn){
                            eraseBtn.tfOn(click,erase_demo);
                        }
                        closeBtn.tfOn(click,close,{once:true});
                        left.tfOn(click,change);
                        right.tfOn(click,change);
                    }
            }
        }
        ThemeDetail.init();
     
    },true);
    
    
    
})( Themify,document,_tbp_admin,undefined);
