<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PTBAudio extends Tbp_Dynamic_Item {

	function is_available() {
		return function_exists( 'run_ptb' );
	}

	function get_category() {
		return 'ptb';
	}

	function get_type() {
		return array( 'text', 'textarea', 'wp_editor', 'url', 'audio' );
	}

	function get_label() {
		return __( 'PTB (Audio)', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value = '';
		if ( ! empty( $args['field'] ) ) {
			$show = isset( $args['show'] ) ? $args['show'] : 'url';
			if ( PTB_Repeater_Field::$in_the_loop ) {
				$n = PTB_Repeater_Field::$repeater_index;
			} else {
				$n = ! empty( $args['n'] ) ? ( (int) $args['n'] - 1 ) : 0;
			}
			$field_name = explode( ':', $args['field'] );
			$cf_value = get_post_meta( get_the_ID(), "ptb_{$field_name[1]}", true );
			if ( isset( $cf_value[ $show ][ $n ] ) && is_array( $cf_value[ $show ] ) ) {
			    $value = $cf_value[ $show ][ $n ];
			}
		}

		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Field', 'tbp' ),
				'id' => 'field',
				'type' => 'select',
				'options' => Tbp_Utils::get_ptb_fields_by_type( 'audio' ),
			),
			array(
				'label' => __( 'Show', 'tbp' ),
				'id' => 'show',
				'type' => 'select',
				'options' => array(
					'url' => __( 'Audio File URL', 'tbp' ),
					'title' => __( 'Title', 'tbp' ),
					'description' => __( 'Description', 'tbp' ),
				),
			),
			array(
				'label' => __( '# Item', 'tbp' ),
				'id' => 'n',
				'type' => 'text',
				'help' => __( 'Number of item in repeatable fields to show.', 'tbp' ),
			),
		);
	}
}