<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */

class Tbp_Dynamic_Item_PTBDate extends Tbp_Dynamic_Item {

	function is_available() {
		return function_exists( 'run_ptb' );
	}

	function get_category() {
		return 'ptb';
	}

	function get_type() {
		return array( 'date' );
	}

	function get_label() {
		return __( 'PTB (Date)', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value = '';
		$args = wp_parse_args( $args, array(
			'show' => 'start_date',
		) );

		if ( ! empty( $args['field'] ) ) {
			list( $post_type, $field_name ) = explode( ':', $args['field'] );
			$value = get_post_meta( get_the_ID(), "ptb_{$field_name}", true );

			// 'range' date fields
			if ( is_array( $value ) ) {
				$value = $value[ $args['show'] ];
			}
		}

		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Field', 'tbp' ),
				'id' => 'field',
				'type' => 'select',
				'options' => Tbp_Utils::get_ptb_fields_by_type( 'event_date' ),
			),
			array(
				'label' => __( 'Show', 'tbp' ),
				'id' => 'show',
				'type' => 'select',
				'options' => array(
					'start_date' => __( 'Start Date', 'tbp' ),
					'end_date' => __( 'End Date', 'tbp' ),
				),
			),
		);
	}
}