<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PTBGallery extends Tbp_Dynamic_Item {

	function is_available() {
		return function_exists( 'run_ptb' );
	}

	function get_category() {
		return 'ptb';
	}

	function get_type() {
		return array( 'gallery', 'wp_editor' );
	}

	function get_label() {
		return __( 'PTB (Gallery)', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value = '';
		if ( ! empty( $args['field'] ) ) {
			$field_name = explode( ':', $args['field'] );
			$value = get_post_meta( get_the_ID(), "ptb_{$field_name[1]}", true );
			if ( isset( $value['url'] ) && is_array( $value['url'] ) ) {
			    $ids = array_filter( array_map( 'attachment_url_to_postid', $value['url'] ) );
			    $value = '[gallery ids="' . implode( ',', $ids ) . '"]';
			}
		}

		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Field', 'tbp' ),
				'id' => 'field',
				'type' => 'select',
				'options' => Tbp_Utils::get_ptb_fields_by_type( [ 'gallery', 'slider' ] ),
			),
		);
	}
}