<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PTBIcon extends Tbp_Dynamic_Item {

	function is_available() {
		return function_exists( 'run_ptb' );
	}

	function get_category() {
		return 'ptb';
	}

	function get_type() {
		return array( 'wp_editor' );
	}

	function get_label() {
		return __( 'PTB (Icons)', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value = '';

		$args = wp_parse_args( $args, array(
			'size' => 'medium',
		) );

		if ( ! empty( $args['field'] ) && function_exists( 'ptb_get_field' ) ) {
			$field_name = explode( ':', $args['field'] );
			return ptb_get_field( $field_name[1], [
				'size' => $args['size'],
			] );
		}

		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Field', 'tbp' ),
				'id' => 'field',
				'type' => 'select',
				'options' => Tbp_Utils::get_ptb_fields_by_type( 'icon' ),
			),
			array(
				'label' => __( 'Icon Size', 'tbp' ),
				'id' => 'size',
				'type' => 'select',
				'options' => array(
					'medium' => __( 'Medium', 'tbp' ),
					'small' => __( 'Small', 'tbp' ),
					'large' => __( 'Large', 'tbp' ),
				),
			),
		);
	}
}