<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PTBIconAsText extends Tbp_Dynamic_Item {

	function is_available() {
		return function_exists( 'run_ptb' );
	}

	function get_category() {
		return 'ptb';
	}

	function get_type() {
		return array( 'text', 'textarea', 'url' );
	}

	function get_label() {
		return __( 'PTB (Icon)', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value = '';
		if ( ! empty( $args['field'] ) ) {
			$show = isset( $args['show'] ) ? $args['show'] : 'url';
			$field_name = explode( ':', $args['field'] );
			$cf_value = get_post_meta( get_the_ID(), "ptb_{$field_name[1]}", true );
			if ( isset( $cf_value[ $show ][0] ) && is_array( $cf_value[ $show ] ) ) {
			    $value = $cf_value[ $show ][0];
			}
		}

		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Field', 'tbp' ),
				'id' => 'field',
				'type' => 'select',
				'options' => Tbp_Utils::get_ptb_fields_by_type( 'icon' ),
			),
			array(
				'label' => __( 'Show', 'tbp' ),
				'id' => 'show',
				'type' => 'select',
				'options' => array(
					'url' => __( 'Icon URL', 'tbp' ),
					'label' => __( 'Icon Label', 'tbp' ),
				),
			),
		);
	}
}