<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PTBText extends Tbp_Dynamic_Item {

	function is_available() {
		return function_exists( 'run_ptb' );
	}

	function get_category() {
		return 'ptb';
	}

	function get_type() {
		return array( 'text', 'textarea', 'wp_editor', 'url' );
	}

	function get_label() {
		return __( 'PTB (Text)', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value = '';
		if ( ! empty( $args['field'] ) ) {
			$sep = isset( $args['sep'] ) ? $args['sep'] : ',';
			list( $post_type, $field_name ) = explode( ':', $args['field'] );
			$value = get_post_meta( get_the_ID(), "ptb_{$field_name}", true );
			if ( is_array( $value ) ) {
				$value = array_filter( $value );
			    // repeatable Text fields
			    $value = ! empty( $value ) ? implode( $sep, $value ) : '';
			}
		}

		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Field', 'tbp' ),
				'id' => 'field',
				'type' => 'select',
				'options' => Tbp_Utils::get_ptb_fields_by_type( 'text' ),
			),
			array(
				'label' => __( 'Separator', 'tbp' ),
				'id' => 'sep',
				'type' => 'text',
				'help' => __( 'Character to separate items in repeatable Text fields.', 'tbp' ),
			),
		);
	}
}