<?php
/**
 * Maps PTB's "video" field type to "wp_editor" field in Builder
 *
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PTBVideoPlaylist extends Tbp_Dynamic_Item {

	function is_available() {
		return function_exists( 'run_ptb' );
	}

	function get_category() {
		return 'ptb';
	}

	function get_type() {
		return array( 'wp_editor' );
	}

	function get_label() {
		return __( 'PTB (Video Playlist)', 'tbp' );
	}

	function get_value( $args = array() ) {
		global $wp_embed;

		$args = wp_parse_args( $args, array(
			'columns' => 1,
		) );

		if ( empty( $args['field'] ) || ! function_exists( 'ptb_get_field' ) ) {
			return '';
		}

		$field_name = explode( ':', $args['field'] );
		$value = ptb_get_field( $field_name[1], [
			'columns' => $args['columns']
		] );

		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Field', 'tbp' ),
				'id' => 'field',
				'type' => 'select',
				'options' => Tbp_Utils::get_ptb_fields_by_type( 'video' ),
			),
			array(
				'label' => __( 'Columns', 'tbp' ),
				'id' => 'columns',
				'type' => 'select',
				'options' => array(
					1 => 1,
					2 => 2,
					3 => 3,
					4 => 4,
				),
			),
		);
	}
}