<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PostTerms extends Tbp_Dynamic_Item {

	function get_category() {
		return 'post';
	}

	function get_type() {
		return array( 'text', 'textarea', 'wp_editor' );
	}

	function get_label() {
		return __( 'Post (Taxonomy) Terms', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value = '';
		if ( ! empty( $args['tax'] ) ) {
			$separator = isset( $args['sep'] ) ? $args['sep'] : ',';
			$terms = get_the_terms( get_the_ID(), $args['tax'] );
			if ( ! is_wp_error( $terms ) && ! empty( $terms ) ) {
				$value = wp_list_pluck( $terms, 'name' );
				$value = implode( $separator, $value );
			}
		}
		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Taxonomy', 'tbp' ),
				'id' => 'tax',
				'type' => 'select',
				'options' => Themify_Builder_Model::get_public_taxonomies(),
			),
			array(
				'label' => __( 'Separator', 'tbp' ),
				'id' => 'sep',
				'type' => 'text',
			),
		);
	}
}
