<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_ProductImage extends Tbp_Dynamic_Item {

	function is_available() {
		return themify_is_woocommerce_active();
	}

	function get_category() {
		return 'wc';
	}

	function get_type() {
		return array( 'image', 'url' );
	}

	function get_label() {
		return __( 'Product Image', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value = '';
		if(empty($args['post_id'])){
		    $the_query = Tbp_Utils::get_wc_actual_query();
		    if($the_query===null || $the_query->have_posts()){
			if($the_query!==null){
			    $the_query->the_post();
			}
			global $product;

			$value = self::get_image( $product );

		    }
		    if($the_query!==null){
			wp_reset_postdata();
		    }
		}
		else{
		    $product = wc_get_product( $args['post_id'] );
		    if(!empty($product)){
				$value = self::get_image( $product );
		    }
		}
		return $value;
	}

	/**
	 * Get the featured image for a product.
	 * For variations, the image for the base product is used as substitute.
	 *
	 * @return string
	 */
	public static function get_image( $product ) {
		$src = $product->get_image_id();
		if ( ! $src ) {
			$p = $product->get_parent_id();
			if ( $p ) {
				$parent_product = wc_get_product( $p );
				if ( $parent_product ) {
					$src = $parent_product->get_image_id();
				}
			}
		}

		return $src ? wp_get_attachment_url( $src ) : '';
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Product ID', 'tbp' ),
				'id' => 'post_id',
				'type' => 'number',
				'help' => __( 'Leave empty to get the data from current product in the loop.', 'tbp' ),
			),
		);
	}
}
