<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_RandomNumber extends Tbp_Dynamic_Item {
	function get_category() {
		return 'general';
	}

	function get_type() {
		return array( 'text', 'textarea', 'wp_editor','slider_range' );
	}

	function get_label() {
		return __( 'Random Number', 'tbp' );
	}

	function get_value( $args = array() ) {
		$min = empty( $args['min'] ) ? 1 : $args['min'];
		$max = empty( $args['max'] ) ? 100 : $args['max'];
		return rand( $min, $max );
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Minimum', 'tbp' ),
				'id' => 'min',
				'type' => 'text',
			),
			array(
				'label' => __( 'Maximum', 'tbp' ),
				'id' => 'max',
				'type' => 'text',
			),
		);
	}
}
