<?php
/**
 * Builder Plugin Compatibility Code
 *
 * @package    Themify_Builder Pro
 */
/**
 * @link https://wordpress.org/plugins/advanced-custom-fields/
 */
class Themify_Builder_Plugin_Compat_acf {

	static function init() {
		add_filter( 'tb_select_dataset_acf_fields', array( __CLASS__, 'tb_select_dataset_acf_fields' ), 10, 2 );
	}

	/**
	 * Populate the ACF field selects
	 *
	 * @return array
	 */
	public static function tb_select_dataset_acf_fields( $data, $post_id ) {
		$args = json_decode( stripslashes( $_POST['args'] ), true );
		return Tbp_Utils::get_acf_fields_by_type( $args['type'] );
	}
}