<?php
/**
 * Builder Plugin Compatibility Code
 *
 * @package    Themify_Builder Pro
 */
/**
 * @link 
 */
class Themify_Builder_Plugin_Compat_ptb {

	static function init() {}

}

/**
 * Utility class to loop through PTB repeatable fields
 * This should be moved to PTB plugin at some point.
 */
class PTB_Repeater_Field {

	public static $repeater_index = -1;
	public static $in_the_loop = false;

	public static function have_rows( $field ) {
		$post_id = get_the_ID();
		if ( $post_id === false ) {
			return false;
		}
		list( $post_type, $field_name, $field_type ) = explode( ':', $field );
		$index_key = $field_type === 'accordion' ? 'body' : 'url'; /* url is the array key used by Audio, Video, File, Gallery and Slider fields */
		$value = get_post_meta( $post_id, "ptb_{$field_name}", true );
		if ( empty( $value[ $index_key ] ) ) {
			return false;
		}
		$count = count( $value[ $index_key ] );
		if ( self::$repeater_index + 1 === $count ) {
			self::$repeater_index = -1; /* reset index */
			return false;
		}
		if ( ! empty( $value[ $index_key ][ self::$repeater_index + 1 ] ) ) {
			return true;
		}
	}

	public static function the_row() {
		self::$repeater_index++;
	}
}