<?php
if (!defined('ABSPATH'))
	exit; // Exit if accessed directly

/**
 * Module Name:Advanced Posts
 * Description:
 */

class TB_Advanced_Posts_Module extends Themify_Builder_Component_Module {
	
    public static $builder_id=null;
    protected static $post_filter;

    public function __construct() {
        if(method_exists('Themify_Builder_Model', 'add_module')){
            parent::__construct('advanced-posts');
        }
        else{//backward
             parent::__construct(array(
                'name' =>$this->get_name(),
                'slug' => 'advanced-posts',
                'category' =>$this->get_group()
            ));
        }
    }

    public function get_name(){
        return  __('Advanced Posts', 'tbp');
    }
    
    public function get_options() {
            $opt = Tbp_Utils::get_module_settings('archive-posts','options');
            $i=2;
            foreach($opt as $k=>$op){
                if ( $i < 1 )
                    break;
                    if ( isset( $op['id']) && $op['id']==='tab_content_archive_posts' ) {
                            unset( $opt[ $k ] );
                            --$i;
                }
                    if(isset($op['id']) && $op['id']==='layout_post'){
                            $opt[$k]['options']=array(
                                    array('img' => 'list_post', 'value' => 'list-post', 'label' => __('List Post', 'tbp')),
                                    array('img' => 'grid2', 'value' => 'grid2', 'label' => __('Grid 2', 'tbp')),
                                    array('img' => 'grid3', 'value' => 'grid3', 'label' => __('Grid 3', 'tbp')),
                                    array('img' => 'grid4', 'value' => 'grid4', 'label' => __('Grid 4', 'tbp')),
                                    array('img' => 'grid5', 'value' => 'grid5', 'label' => __('Grid 5', 'tbp')),
                                    array('img' => 'grid6', 'value' => 'grid6', 'label' => __('Grid 6', 'tbp')),
                            );
                            $opt[$k]['binding']=array(
                                    'list-post' => array('hide' => 'masonry'),
                                    'grid2' => array('show' => 'masonry'),
                                    'grid3' => array('show' => 'masonry'),
                                    'grid4' => array('show' => 'masonry'),
                                    'grid5' => array('show' =>'masonry'),
                                    'grid6' => array('show' => 'masonry'),
                            );
                            --$i;
                    }
            }
            return array_merge( array(
                    array(
                            'id'      => 'builder_content',
                            'type'    => 'tbp_advanched_layout',
                            'control' => false
                    ),
                    array(
                            'type' => 'query_posts',
                            'id' => 'post_type',
                            'tax_id' => 'tax',
                            'term_id' => 'terms',
                            'slug_id' => 'slug',
                            'wrap_class' => 'tbp_app_post_query',
                            'query_filter' => true,
                    ),
            ), $opt );
    }

    public function get_group() {
        return array( 'archive', 'general' );
    }

    public function get_icon(){
        return 'layout-grid2';
    }

    public function get_styling() {
            $general = array(
                    // Background
                    self::get_expand('bg', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_image('', 'b_c_g', 'bg_c', 'background-color')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_image('', 'b_c_g', 'bg_c', 'background-color', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Font
                    self::get_expand('f', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_font_family('', 'f_f_g'),
                                            self::get_color_type(array(' span', ' a:not(.post-edit-link)', ' p', ' .tbp_post_date')),
                                            self::get_font_size('', 'f_s_g'),
                                            self::get_line_height('', 'l_h_g'),
                                            self::get_letter_spacing(' .post', 'l_s_g'),
                                            self::get_text_align(' .post', 't_a_g'),
                                            self::get_text_transform('', 't_t_g'),
                                            self::get_font_style('', 'f_g', 'f_b'),
                                            self::get_text_shadow('', 't_sh'),
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_font_family('', 'f_f_g', 'h'),
                                            self::get_color_type(array(' span', ' a:not(.post-edit-link)', ' p', ' .tbp_post_date'), 'h'),
                                            self::get_font_size('', 'f_s_g', '', 'h'),
                                            self::get_font_style('', 'f_g', 'f_b', 'h'),
                                            self::get_text_shadow('','t_sh','h'),
                                    )
                                    )
                            ))
                    )),
                    // Padding
                    self::get_expand('p', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_padding('', 'g_p')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_padding('', 'g_p', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Margin
                    self::get_expand('m', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_margin('', 'g_m')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_margin('', 'g_m', 'h')
                                    )
                                    )
                            )),
                    )),
                    // Border
                    self::get_expand('b', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_border('', 'g_b')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_border('', 'g_b', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Filter
                    self::get_expand('f_l',
                            array(
                                    self::get_tab(array(
                                            'n' => array(
                                                    'options' => count($a = self::get_blend())>2 ? array($a) : $a
                                            ),
                                            'h' => array(
                                                    'options' => count($a = self::get_blend('','bl_m_h','h'))>2 ? array($a + array('ishover'=>true)) : $a
                                            )
                                    ))
                            )
                    ),
                    // Width
                    self::get_expand('w', array(
                        self::get_width('', 'w')
                    )),
                    // Height & Min Height
                    ! method_exists( $this, 'get_max_height' ) ? array() :
                    self::get_expand('ht', array(
                                    self::get_height(),
                                    self::get_min_height(),
                                    self::get_max_height()
                            )
                    ),
                    // Rounded Corners
                    self::get_expand('r_c', array(
                            self::get_tab(array(
                                    'n' => array(
                                            'options' => array(
                                                    self::get_border_radius('', 'r_c')
                                            )
                                    ),
                                    'h' => array(
                                            'options' => array(
                                                    self::get_border_radius('', 'r_c', 'h')
                                            )
                                    )
                            ))
                    )),
                    // Shadow
                    self::get_expand('sh', array(
                            self::get_tab(array(
                                    'n' => array(
                                            'options' => array(
                                                    self::get_box_shadow('', 'g_sh')
                                            )
                                    ),
                                    'h' => array(
                                            'options' => array(
                                                    self::get_box_shadow('', 'g_sh', 'h')
                                            )
                                    )
                            ))
                    )),
                    // Display
                    self::get_expand('disp', self::get_display())
            );

            $aap_container = array(
                    // Background
                    self::get_expand('bg', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_color(' .post', 'b_c_aap_cn', 'bg_c', 'background-color')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_color(' .post', 'b_c_aap_cn', 'bg_c', 'background-color', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Padding
                    self::get_expand('p', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_padding(' .post', 'p_aap_cn')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_padding(' .post', 'p_aap_cn', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Margin
                    self::get_expand('m', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_heading_margin_multi_field(' .post', '', 'top', 'article'),
                                            self::get_heading_margin_multi_field(' .post', '', 'bottom', 'article')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_heading_margin_multi_field(' .post', '', 'top', 'article', 'h'),
                                            self::get_heading_margin_multi_field(' .post', '', 'bottom', 'article', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Border
                    self::get_expand('b', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_border(' .post', 'p_aap_cn')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_border(' .post', 'p_aap_cn', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Rounded Corners
                    self::get_expand('r_c', array(
                            self::get_tab(array(
                                    'n' => array(
                                            'options' => array(
                                                    self::get_border_radius(' .post', 'r_c_aap_cn')
                                            )
                                    ),
                                    'h' => array(
                                            'options' => array(
                                                    self::get_border_radius(' .post', 'r_c_aap_cn', 'h')
                                            )
                                    )
                            ))
                    )),
                    // Shadow
                    self::get_expand('sh', array(
                            self::get_tab(array(
                                    'n' => array(
                                            'options' => array(
                                                    self::get_box_shadow(' .post', 'sh_aap_cn')
                                            )
                                    ),
                                    'h' => array(
                                            'options' => array(
                                                    self::get_box_shadow(' .post', 'sh_aap_cn', 'h')
                                            )
                                    )
                            ))
                    )),
            );

            $pg_container = array(
                    // Background
                    self::get_expand('bg', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_color(' .pagenav', 'b_c_pg_c', 'bg_c', 'background-color')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_color(' .pagenav', 'b_c_pg_c', 'bg_c', 'background-color', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Font
                    self::get_expand('f', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_font_family(' .pagenav', 'f_f_pg_c'),
                                            self::get_color(' .pagenav', 'f_c_pg_c'),
                                            self::get_font_size(' .pagenav', 'f_s_pg_c'),
                                            self::get_line_height(' .pagenav', 'l_h_pg_c'),
                                            self::get_letter_spacing(' .pagenav', 'l_s_pg_c'),
                                            self::get_text_align(' .pagenav', 't_a_pg_c'),
                                            self::get_font_style(' .pagenav', 'f_st_pg_c', 'f_b_pg_c'),
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_font_family(' .pagenav', 'f_f_pg_c', 'h'),
                                            self::get_color(' .pagenav', 'f_c_pg_c','h'),
                                            self::get_font_size(' .pagenav', 'f_s_pg_c', '', 'h'),
                                            self::get_font_style(' .pagenav', 'f_st_pg_c', 'f_b_pg_c', 'h'),
                                    )
                                    )
                            ))
                    )),
                    // Padding
                    self::get_expand('p', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_padding(' .pagenav', 'p_pg_c')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_padding(' .pagenav', 'p_pg_c', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Margin
                    self::get_expand('m', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_margin(' .pagenav', 'm_pg_c')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_margin(' .pagenav', 'm_pg_c', 'h')
                                    )
                                    )
                            )),
                    )),
                    // Border
                    self::get_expand('b', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_border(' .pagenav', 'b_pg_c')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_border(' .pagenav', 'b_pg_c', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Rounded Corners
                    self::get_expand('r_c', array(
                            self::get_tab(array(
                                    'n' => array(
                                            'options' => array(
                                                    self::get_border_radius(' .pagenav', 'r_c_pg_c')
                                            )
                                    ),
                                    'h' => array(
                                            'options' => array(
                                                    self::get_border_radius(' .pagenav', 'r_c_pg_c', 'h')
                                            )
                                    )
                            ))
                    )),
                    // Shadow
                    self::get_expand('sh', array(
                            self::get_tab(array(
                                    'n' => array(
                                            'options' => array(
                                                    self::get_box_shadow(' .pagenav', 'sh_pg_c')
                                            )
                                    ),
                                    'h' => array(
                                            'options' => array(
                                                    self::get_box_shadow(' .pagenav', 'sh_pg_c', 'h')
                                            )
                                    )
                            ))
                    ))
            );

            $pg_numbers = array(
                    // Background
                    self::get_expand('bg', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_color(' .pagenav a', 'b_c_pg_n', 'bg_c', 'background-color')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_color(' .pagenav a', 'b_c_pg_n', 'bg_c', 'background-color', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Font
                    self::get_expand('f', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_font_family(' .pagenav a', 'f_f_pg_n'),
                                            self::get_color(' .pagenav a', 'f_c_pg_n'),
                                            self::get_font_size(' .pagenav a', 'f_s_pg_n'),
                                            self::get_line_height(' .pagenav a', 'l_h_pg_n'),
                                            self::get_letter_spacing(' .pagenav a', 'l_s_pg_n'),
                                            self::get_font_style(' .pagenav a', 'f_st_pg_n', 'f_b_pg_n'),
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_font_family(' .pagenav a', 'f_f_pg_n', 'h'),
                                            self::get_color(' .pagenav a', 'f_c_pg_n','h'),
                                            self::get_font_size(' .pagenav a', 'f_s_pg_n', '', 'h'),
                                            self::get_font_style(' .pagenav a', 'f_st_pg_n', 'f_b_pg_n', 'h'),
                                    )
                                    )
                            ))
                    )),
                    // Padding
                    self::get_expand('p', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_padding(' .pagenav a', 'p_pg_n')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_padding(' .pagenav a', 'p_pg_n', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Margin
                    self::get_expand('m', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_margin(' .pagenav a', 'm_pg_n')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_margin(' .pagenav a', 'm_pg_n', 'h')
                                    )
                                    )
                            )),
                    )),
                    // Border
                    self::get_expand('b', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_border(' .pagenav a', 'b_pg_n')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_border(' .pagenav a', 'b_pg_n', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Rounded Corners
                    self::get_expand('r_c', array(
                            self::get_tab(array(
                                    'n' => array(
                                            'options' => array(
                                                    self::get_border_radius(' .pagenav a', 'r_c_pg_n')
                                            )
                                    ),
                                    'h' => array(
                                            'options' => array(
                                                    self::get_border_radius(' .pagenav a', 'r_c_pg_n', 'h')
                                            )
                                    )
                            ))
                    )),
                    // Shadow
                    self::get_expand('sh', array(
                            self::get_tab(array(
                                    'n' => array(
                                            'options' => array(
                                                    self::get_box_shadow(' .pagenav a', 'sh_pg_n')
                                            )
                                    ),
                                    'h' => array(
                                            'options' => array(
                                                    self::get_box_shadow(' .pagenav a', 'sh_pg_n', 'h')
                                            )
                                    )
                            ))
                    ))
            );

            $pg_a_numbers = array(
                    // Background
                    self::get_expand('bg', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_color(' .pagenav .current', 'b_c_pg_a_n', 'bg_c', 'background-color')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_color(' .pagenav .current', 'b_c_pg_a_n', 'bg_c', 'background-color', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Font
                    self::get_expand('f', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_font_family(' .pagenav .current', 'f_f_pg_a_n'),
                                            self::get_color(' .pagenav .current', 'f_c_pg_a_n'),
                                            self::get_font_size(' .pagenav .current', 'f_s_pg_a_n'),
                                            self::get_line_height(' .pagenav .current', 'l_h_pg_a_n'),
                                            self::get_letter_spacing(' .pagenav .current', 'l_s_pg_a_n'),
                                            self::get_font_style(' .pagenav .current', 'f_st_pg_a_n', 'f_b_pg_a_n'),
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_font_family(' .pagenav .current', 'f_f_pg_a_n', 'h'),
                                            self::get_color(' .pagenav .current', 'f_c_pg_a_n','h'),
                                            self::get_font_size(' .pagenav .current', 'f_s_pg_a_n', '', 'h'),
                                            self::get_font_style(' .pagenav .current', 'f_st_pg_a_n', 'f_b_pg_a_n', 'h'),
                                    )
                                    )
                            ))
                    )),
                    // Padding
                    self::get_expand('p', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_padding(' .pagenav .current', 'p_pg_a_n')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_padding(' .pagenav .current', 'p_pg_a_n', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Margin
                    self::get_expand('m', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_margin(' .pagenav .current', 'm_pg_a_n')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_margin(' .pagenav .current', 'm_pg_a_n', 'h')
                                    )
                                    )
                            )),
                    )),
                    // Border
                    self::get_expand('b', array(
                            self::get_tab(array(
                                    'n' => array(
                                    'options' => array(
                                            self::get_border(' .pagenav .current', 'b_pg_a_n')
                                    )
                                    ),
                                    'h' => array(
                                    'options' => array(
                                            self::get_border(' .pagenav .current', 'b_pg_a_n', 'h')
                                    )
                                    )
                            ))
                    )),
                    // Rounded Corners
                    self::get_expand('r_c', array(
                            self::get_tab(array(
                                    'n' => array(
                                            'options' => array(
                                                    self::get_border_radius(' .pagenav .current', 'r_c_pg_a_n')
                                            )
                                    ),
                                    'h' => array(
                                            'options' => array(
                                                    self::get_border_radius(' .pagenav .current', 'r_c_pg_a_n', 'h')
                                            )
                                    )
                            ))
                    )),
                    // Shadow
                    self::get_expand('sh', array(
                            self::get_tab(array(
                                    'n' => array(
                                            'options' => array(
                                                    self::get_box_shadow(' .pagenav .current', 'sh_pg_a_n')
                                            )
                                    ),
                                    'h' => array(
                                            'options' => array(
                                                    self::get_box_shadow(' .pagenav .current', 'sh_pg_a_n', 'h')
                                            )
                                    )
                            ))
                    ))
            );

            return array(
                    'type' => 'tabs',
                    'options' => array(
                            'g' => array(
                                    'options' => $general
                            ),
                            'po_c' => array(
                                    'label' => __('Post Container', 'tbp'),
                                    'options' => $aap_container
                            ),
                            'pg_c' => array(
                                    'label' => __('Pagination Container', 'tbp'),
                                    'options' => $pg_container
                            ),
                            'pg_n' => array(
                                    'label' => __('Pagination Numbers', 'tbp'),
                                    'options' => $pg_numbers
                            ),
                            'pg_a_n' => array(
                                    'label' => __('Pagination Active', 'tbp'),
                                    'options' => $pg_a_numbers
                            )
                    )
            );



    }

    public function get_animation() {
            return false;
    }

    public function get_live_default() {
            $arr = array();
            $defaultModules=array(
                'featured-image',
                'post-title',
                'post-meta',
                'post-content'
            );
            foreach($defaultModules as $m){
                if(isset(Themify_Builder_Model::$modules[$m])){
		    $item=array(
                        'mod_name'=>$m,
                        'mod_settings'=>Themify_Builder_Model::$modules[$m]->get_live_default()
                    );
		    if($m==='post-content'){
			$item['mod_settings']['content_type'] = 'excerpt';
		    }
                    $arr[] = $item;
                }
            }
            
            $defaultModules=null;
            $default =Tbp_Utils::get_module_settings('archive-posts');
            unset($default['tab_content_archive_posts']);
            $default['builder_content']=array(
                array(
                    'cols'=>array(
                        array(
                            'grid_class'=>'col-full',
                            'modules'=>$arr
                        )
                    )
                )
            );
            return $default;
    }


    public function get_category() {
            return array( 'single', 'archive', 'page' );
    }

    /**
     * Render plain content for static content.
     * 
     * @param array $module 
     * @return string
     */
    public function get_plain_content($module) {
		return '';
    }
}
if(method_exists('Themify_Builder_Model', 'add_module')){
    new TB_Advanced_Posts_Module();
}
else{
    Themify_Builder_Model::register_module('TB_Advanced_Posts_Module');
}
