<?php
if ( ! defined( 'ABSPATH' ) )
	exit; // Exit if accessed directly

/**
 * Module Name: Archive Image
 * Description: 
 */
class TB_Archive_Image_Module extends Themify_Builder_Component_Module {
	
	public function __construct() {
            if(method_exists('Themify_Builder_Model', 'add_module')){
                parent::__construct('archive-image');
            }
            else{//backward
                 parent::__construct(array(
                    'name' =>$this->get_name(),
                    'slug' => 'archive-image',
                    'category' =>$this->get_group()
                ));
            }
	}
        
        public function get_name(){
            return  __('Archive Cover Image', 'tbp');
        }
        
        public function get_icon(){
		return 'image';
	}
        
        public function get_group() {
            return array('archive','product_archive');
        }
        
	public function get_assets() {
		return array(
			'css' => 'image'
		);
	}
        
	public function get_options() {
		$options = Tbp_Utils::get_module_settings( 'image', 'options' );
		foreach ( $options as $index => $option ) {
			if ( ! isset( $option['id'] ) ) {
				continue;
			}
			if ( in_array( $option['id'], [ 'url_image', 'title_image', 'link_image', 'caption_image', 'alt_image', 'param_image', 'multi_lightbox', 'image_zoom_icon' ],true ) ) {
				unset( $options[ $index ] );
			}
		}

		return $options;
	}

	public function get_styling() {
	    return  Tbp_Utils::get_module_settings( 'image', 'styling' );
	}

}
if(method_exists('Themify_Builder_Model', 'add_module')){
    new TB_Archive_Image_Module();
}
else{
    Themify_Builder_Model::register_module('TB_Archive_Image_Module');
}