<?php
if (!defined('ABSPATH'))
    exit; // Exit if accessed directly

/**
 * Module Name: WooCommerce Hook
 * Description: 
 */

class TB_WooCommerce_Hook_Module extends Themify_Builder_Component_Module {

    public function __construct() {
        if(method_exists('Themify_Builder_Model', 'add_module')){
            parent::__construct('woocommerce-hook');
        }
        else{//backward
             parent::__construct(array(
                'name' =>$this->get_name(),
                'slug' => 'woocommerce-hook',
                'category' =>$this->get_group()
            ));
        }
    }
    
    public function get_name(){
        return __('WooCommerce Hook', 'tbp');
    }
    
    public function get_icon(){
	return 'layout-menu-separated';
    }
    
    public function get_group() {
        return array( 'product_single' );
    }
    
    public function get_options() {
		return array(
			array(
				'id' => 'hook',
                'type' => 'select',
                'options' => array(
                    '' => '',
                    'woocommerce_before_single_product_summary' => 'woocommerce_before_single_product_summary',
                    'woocommerce_single_product_summary' => 'woocommerce_single_product_summary',
                    'woocommerce_share' => 'woocommerce_share',
                    'woocommerce_after_single_product_summary' => 'woocommerce_after_single_product_summary',
                ),
				'label' => __('Hook', 'tbp'),
                'required' => array(
                    'message' => __("Please select a WooCommerce Hook.", 'tbp')
                ),
                'help' => __('Some WooCommerce extensions use hooks to display their content. Select a hook which you want to include in the template.', 'tbp')
			),
			array( 'type' => 'custom_css_id', 'custom_css' => 'css' ),
		);
	}

	public function get_styling() {

		return array(
			'type' => 'tabs',
			'options' => array(
				'g' => array(
					'options' => array()
				)
			)
		);
	}

	public function get_category() {
		return array( 'product' );
	}

    public static function do_action($hook){
        $wc_dir = dirname( WC_PLUGIN_FILE );
        global $wp_filter;
        if(isset($wp_filter) && !empty($wp_filter[$hook])){
            $hooks=$wp_filter[$hook];
            if(is_object($hooks) && is_array($hooks->callbacks)){
                foreach($hooks->callbacks as $priority=>$action){
                    if(is_array($action) && !empty($action)){
                        foreach($action as $k=>$f){
                            if(is_string($action[$k]['function']) && function_exists($action[$k]['function'])){
                                $func = new ReflectionFunction($action[$k]['function']);
                                $func_dir = $func->getFileName();
                                if(strpos($func_dir,$wc_dir)===0){
                                    remove_action($hook,$action[$k]['function'],$priority);
                                }
                            }
                        }
                    }
                }
            }
        }
        do_action($hook);
    }

}

if (themify_is_woocommerce_active()) {
    if(method_exists('Themify_Builder_Model', 'add_module')){
        new TB_WooCommerce_Hook_Module();
    }
    else{
        Themify_Builder_Model::register_module('TB_WooCommerce_Hook_Module');
    }
}
