/**
 * Cart Icon module
 */
;
(($,Themify,doc)=>{
	'use strict';
	Themify.on( 'builder_load_module_partial',(el,isLazy)=>{
		if(Themify.is_builder_active || (isLazy===true && !el.classList.contains('module-cart-icon'))){
			return;
		}
		const items = Themify.selectWithParent('tbp_slide_cart',el),
            carts = Themify.selectWithParent('[data-show]',el);
		for(let i=items.length-1;i>-1;--i){
			Themify.sideMenu(items[i].previousElementSibling,{
				close: '#' + items[i].tfClass('tbp_cart_icon_close')[0].id
			}).then(()=>{
                items[i].classList.remove('tf_hide');
            });
		}
		for(let i=carts.length-1;i>-1;--i){
			let isWorking = false;
			// Show & Hide cart icon on add to cart event
			Themify.body.on( 'added_to_cart',  ()=>{
				if(isWorking===false){
					isWorking=true;
					let seconds=parseInt(carts[i].dataset.show)*1000;
					if(!carts[i].classList.contains('tbp_cart_icon_style_dropdown')){
						const panel=carts[i].tfClass('tbp_sidemenu')[0];
						if(panel){
							const panelId = '#'+panel.id,
                                bodyCl=doc.body.classList;
							Themify.on('sidemenushow', (panel_id, side,_this)=>{
								if(panelId===panel_id){
									setTimeout( ()=> {
										if($(panel).is(':hover')){
											panel.tfOn('mouseleave',()=>{
												_this.hidePanel();
												bodyCl.remove('tf_auto_cart_open');
											},{once:true,passive:true});
										}
                                        else{
											_this.hidePanel();
											bodyCl.remove('tf_auto_cart_open');
										}
										isWorking=false;
									},seconds);
								}
							},true);
							bodyCl.add('tf_auto_cart_open');
							setTimeout(()=>{
								carts[i].querySelector('a').click();
							},100);
						}
					}
					else{
						const item = carts[i].tfClass('tbp_cart_icon_container')[0];
						item.classList.add( 'tbp_show_cart' );
						setTimeout(()=> {
							item.classList.remove( 'tbp_show_cart' );
							isWorking=false;
						},seconds);
					}
				}
			} );
		}
	});
})( jQuery,Themify,document );
