( ( Themify, doc ) => {
    'use strict';
	if ( Themify.is_builder_active ) {
		return;
	}

	let bar, start, end, range;

	if ( doc.readyState === 'complete' ) {
		init();
	} else {
		window.addEventListener( 'load', init );
	}

	function init() {
		bar = doc.getElementById( 'tbp_read_bar' );
		const rect = bar.parentElement.getBoundingClientRect();
		start = rect.top + window.scrollY;
		end = ( start + rect.height ) - window.innerHeight;
		range = Math.abs( end - start );
		doc.addEventListener( 'scroll', updateBar );
	}

	function updateBar() {
		let scroll = (window.pageYOffset || doc.scrollTop),
			offset = scroll - start,
			actual = offset / range;
		actual = actual > 1 ? 100 : ( actual < 0 ? 0 : actual * 100 );
		bar.style.width = actual + "%";
		if ( actual == 0 || actual == 100 ) {
			bar.style.display = 'none';
		} else {
			bar.style.display = 'block';
		}
	}

} )( Themify, document );
