( ( Themify, doc ) => {
    'use strict';

    Themify.on( 'builder_load_module_partial', ( el, isLazy ) => {
        if ( isLazy === true && ! el.classList.contains( 'module-readtime' ) ) {
            return;
        }
        const items = Themify.selectWithParent( '.tbp_rd_tm[data-id]', el );
		let ids = [];
        for ( let i = items.length - 1; i > -1; --i ) {
            ids.push( items[ i ].dataset.id );
        }
		if ( ! ids.length ) {
			return;
		}
		const nonce = items[0].dataset.nonce;
		ids = [...new Set(ids)]; /* gather unique values */

		/* query content length by ID, in chunks */
		const limit = 10;
		for ( let i = 1; i <= Math.ceil( ids.length / limit ); i++ ) {
			const slice = ids.slice( ( i - 1 ) * limit, i * limit );
			Themify.fetch( {
				action : 'tbp_readtime_calculate',
				nonce : nonce,
				ids : slice,
			} ).then( function( result ) {
				if ( ! result.success ) {
					return;
				}

				/* loop through the ajax result */
				Object.keys( result.data ).forEach( function( key ) {
					const elements = doc.querySelectorAll( '.tbp_rd_tm[data-id="' + key + '"]' ),
						time = result.data[ key ] / 250;
					/* set up a loop for each post ID, in case there are multiple instances of the same post on the page */
					for ( let j = elements.length - 1; j > -1; --j ) {
						if ( time < 1 ) {
							elements[ j ].querySelector( '.tbp_rd_tm_b' ).remove();
							elements[ j ].querySelector( '.tbp_rd_tm_a' ).remove();
						} else {
							elements[ j ].querySelector( '.tbp_rd_tm_less' ).remove();
							const text = doc.createElement( 'span' );
							text.textContent = Math.ceil( time ).toString();
							elements[ j ].querySelector( '.tbp_rd_tm_b' ).insertAdjacentElement( 'afterend', text );
						}
						elements[ j ].classList.remove( 'tf_hide' );
					}
				} );
			} );
		}
    });

} )( Themify, document );
