<?php
if (!defined('ABSPATH'))
    exit; // Exit if accessed directly
/**
 * Template Product Price
 * 
 * Access original fields: $args['mod_settings']
 * @author Themify
 */
global $product;

if (themify_is_woocommerce_active()):
    $fields_default = array(
	'css' => '',
	'hide_regular_price' => '',
	'sale_percentage' => '',
	'sale_percentage_lbl' => '',
	'animation_effect' => ''
    );
    $fields_args = wp_parse_args($args['mod_settings'], $fields_default);
    unset($args['mod_settings']);
    $fields_default=null;
    $mod_name=$args['mod_name'];
    $element_id =$args['module_ID'];
    $builder_id=$args['builder_id'];
    $container_class = apply_filters('themify_builder_module_classes', array(
	'module',
	'module-' . $mod_name,
	'product-price',
	$element_id,
	$fields_args['css']
	    ), $mod_name, $element_id, $fields_args);

    if(!empty($fields_args['global_styles']) && Themify_Builder::$frontedit_active===false){
	$container_class[] = $fields_args['global_styles'];
    }
	$container_props = apply_filters('themify_builder_module_container_props', self::parse_animation_effect($fields_args,array(
	'class' => implode(' ', $container_class),
	    )), $fields_args, $mod_name, $element_id);
    $args = null;
	if(Themify_Builder::$frontedit_active===false){
		$container_props['data-lazy']=1;
	}
    ?>
    <!-- Product Price module -->
    <div <?php echo self::get_element_attributes(self::sticky_element_props($container_props, $fields_args)); ?>>
	<?php
	$container_props=$container_class=null;
	$the_query = Tbp_Utils::get_wc_actual_query();
	if ($the_query===null || $the_query->have_posts()){
	    if($the_query!==null){
		$the_query->the_post();
	    }

		if ( $product && $product->is_on_sale() ) {
			if ( $fields_args['sale_percentage'] === 'y' ) {
				TB_Product_Price_Module::$cache_sale_label = $fields_args['sale_percentage_lbl'];
				add_filter( 'woocommerce_get_price_html', [ 'TB_Product_Price_Module', 'woocommerce_get_price_html' ], 10, 2 );
			}
			if ( $fields_args['hide_regular_price'] === 'y' ) {
				add_filter( 'woocommerce_format_sale_price', [ 'TB_Product_Price_Module', 'woocommerce_format_sale_price' ], 10, 3 );
			}
		}

		woocommerce_template_single_price();

		if ( $product && $product->is_on_sale() ) {
			TB_Product_Price_Module::$cache_sale_label = null;
			remove_filter( 'woocommerce_get_price_html', [ 'TB_Product_Price_Module', 'woocommerce_get_price_html' ], 10 );
			remove_filter( 'woocommerce_format_sale_price', [ 'TB_Product_Price_Module', 'woocommerce_format_sale_price' ], 10, 3 );
		}

	    if($the_query!==null){
		wp_reset_postdata();
	    }
	}
	?>
    </div>
    <!-- /Product Price module -->
<?php endif; ?>
