<?php
if ( ! defined( 'ABSPATH' ) )
    exit; // Exit if accessed directly

global $more;
/**
 * Template Read Time
 *
 * Access original fields: $args['mod_settings']
 * @author Themify
 */
$fields_default = array(
	'm_t' => '',
	'ic' => '',
	'less' => '',
	'b_text' => '',
	'a_text' => '',
	'css' => '',
);
$fields_args = wp_parse_args( $args['mod_settings'], $fields_default );
unset( $args['mod_settings'] );
$fields_default = null;
$mod_name = $args['mod_name'];
$builder_id = $args['builder_id'];
$element_id =$args['module_ID'];
$container_class = apply_filters( 'themify_builder_module_classes', array(
    'module',
    'module-' . $mod_name,
    $element_id,
    $fields_args['css']
), $mod_name, $element_id, $fields_args );

if ( ! empty( $fields_args['global_styles'] ) && Themify_Builder::$frontedit_active === false ) {
    $container_class[] = $fields_args['global_styles'];
}
$container_props = apply_filters('themify_builder_module_container_props', self::parse_animation_effect( $fields_args, array(
    'class' => implode( ' ', $container_class ),
) ), $fields_args, $mod_name, $element_id );
$args = null;
if ( Themify_Builder::$frontedit_active === false ) {
    $container_props['data-lazy'] = 1;
}
/**
 * 250 is the average read time for adults
 * source: https://irisreading.com/what-is-the-average-reading-speed/
 */
$words_per_minute = 250;
?>
<!-- Post Read Time -->
<div <?php echo self::get_element_attributes( self::sticky_element_props( $container_props, $fields_args ) );?>>
	<?php
	$container_props = $container_class = null;
	echo Themify_Builder_Component_Module::get_module_title( $fields_args );
	$the_query = Tbp_Utils::get_actual_query();
	if ( $the_query===null || $the_query->have_posts() ) {
	    if ( $the_query !== null ) {
			$the_query->the_post();
	    }

		$key = 'tbp_readtime_' . get_the_ID() . get_post_timestamp( null, 'modified' );
		$word_count = get_transient( $key );
		echo '<div class="tbp_rd_tm';
		if ( ! $word_count ) {
			printf( ' tf_hide" data-id="%s" data-nonce="%s', get_the_ID(), wp_create_nonce( 'tbp_readtime' ) );
		}
		echo '">';

		if ( ! empty( $fields_args['ic'] ) ) {
			echo '<span class="tbp_rd_tm_ic tf_inline_b">' . themify_get_icon( $fields_args['ic'] ) . '</span> ';
		}

		$read_time = '';
		if ( $word_count ) {
			$read_time = $word_count / $words_per_minute;
		}

		if ( ! $word_count || 1 > $read_time ) {
			echo '<span class="tbp_rd_tm_less">' . $fields_args['less'] . '</span>';
		}
		if ( ! $word_count || 1 < $read_time ) {
			echo '<span class="tbp_rd_tm_b">' . $fields_args['b_text'] . '</span>';
			echo $word_count ? '<span>' . ceil( $read_time ) . '</span>' : '';
			echo '<span class="tbp_rd_tm_a">' . $fields_args['a_text'] . '</span>';
		}

		echo '</div><!-- .tbp_rd_tm -->';

	    if ( $the_query !== null ) {
			wp_reset_postdata();
	    }
	}
    ?>
</div><!-- /Post Read Time -->