<?php
if (!defined('ABSPATH'))
    exit; // Exit if accessed directly
/**
 * Template Related Products
 * 
 * Access original fields: $args['mod_settings']
 * @author Themify
 */
if (themify_is_woocommerce_active()):
    $fields_default = array(
	'heading' => '',
	'layout' => 'grid3',
	'limit' => '',
	'image_w' => '',
	'image_h' => '',
	'css' => '',
	'animation_effect' => ''
    );
    $fields_args = wp_parse_args($args['mod_settings'], $fields_default);
    unset($args['mod_settings']);
    $fields_default=null;
    $mod_name=$args['mod_name'];
    $element_id =$args['module_ID'];
    $builder_id=$args['builder_id'];
    $container_class = apply_filters('themify_builder_module_classes', array(
	'module',
	'module-' . $mod_name,
	'woocommerce',
	$element_id,
	$fields_args['css']
	    ), $mod_name, $element_id, $fields_args);
 
    if(!empty($fields_args['global_styles']) && Themify_Builder::$frontedit_active===false){
	$container_class[] = $fields_args['global_styles'];
    }
	$container_props = apply_filters('themify_builder_module_container_props', self::parse_animation_effect($fields_args,array(
	'class' => implode(' ', $container_class),
	    )), $fields_args, $mod_name, $element_id);
    $args=null;
	if(Themify_Builder::$frontedit_active===false){
		$container_props['data-lazy']=1;
	}
    ?>
    <!-- Related Products module -->
    <div <?php echo self::get_element_attributes(self::sticky_element_props($container_props, $fields_args)); ?>>
	<?php
	$container_props=$container_class=null; 
	global $product;
	$the_query = Tbp_Utils::get_wc_actual_query();
	if ($the_query===null || $the_query->have_posts()) :
	    if($the_query!==null){
		$the_query->the_post();
	    }
	    global $themify, $product;
	    $col = 3;
	    if ($fields_args['layout'] === 'grid2') {
		    $col = 2;
	    } elseif ($fields_args['layout'] === 'grid4') {
		    $col = 4;
	    }elseif ($fields_args['layout'] === 'grid5') {
            $col = 5;
        }elseif ($fields_args['layout'] === 'grid6') {
            $col = 6;
        }
	    
	    $attr = array(
		'posts_per_page' => empty($fields_args['limit']) ? $col : $fields_args['limit'],
		'columns' => $col,
		'orderby' => 'rand',
		'order' => 'desc'
	    );
	    // Get visible related products then sort them at random.
	    $related_products = array_filter(array_map('wc_get_product', wc_get_related_products($product->get_id(), $attr['posts_per_page'], $product->get_upsell_ids())), 'wc_products_array_filter_visible');
	    // Handle orderby.
	    $related_products = wc_products_array_orderby($related_products, $attr['orderby'], $attr['order']);
	    if (!empty($related_products)) :
            if(!empty($fields_args['image_w']) || !empty($fields_args['image_h'])){
                wc_set_loop_prop('related_image_size_w', $fields_args['image_w']);
                wc_set_loop_prop('related_image_size_h', $fields_args['image_h']);
                if(isset($GLOBALS['themify'])){
                    $GLOBALS['themify']->width=$fields_args['image_w'];
                    $GLOBALS['themify']->height=$fields_args['image_h'];
                }
                add_filter('woocommerce_product_get_image',array('TB_Related_Products_Module','set_image_size'),PHP_INT_MAX,2);
                add_filter('wp_img_tag_add_srcset_and_sizes_attr', '__return_false',PHP_INT_MAX);
            }
		wc_set_loop_prop('name', 'related');
		wc_set_loop_prop('columns', apply_filters('woocommerce_related_products_columns', $attr['columns']));
	    ?>
	        <section class="related tbp_posts_wrap">
				<?php if ($fields_args['heading'] !== ''): ?>
					<h2<?php if(method_exists('Themify_Builder_Component_Base','add_inline_edit_fields')){self::add_inline_edit_fields('heading');}?>><?php echo $fields_args['heading']; ?></h2>
				<?php endif; ?>
				
				<?php 
				woocommerce_product_loop_start();
				$isLoop=$ThemifyBuilder->in_the_loop===true;
				$ThemifyBuilder->in_the_loop = true;
				foreach ($related_products as $rel){

					$post_object = get_post($rel->get_id());

					setup_postdata($GLOBALS['post'] = &$post_object);
					global $themify;
					$temp_content = $themify->display_content;
					$themify->display_content='none'; // Hide the product description in Themify themes
					wc_get_template_part('content', 'product');
					$themify->display_content=$temp_content;
				}
				woocommerce_product_loop_end(); 
				$ThemifyBuilder->in_the_loop = $isLoop;
				?>

	        </section>
	    <?php endif;
	    if($the_query!==null){
		wp_reset_postdata();
	    }
        if(!empty($fields_args['image_w']) || !empty($fields_args['image_h'])){
            remove_filter('woocommerce_product_get_image',array('TB_Related_Products_Module','set_image_size'),PHP_INT_MAX);
            remove_filter('wp_img_tag_add_srcset_and_sizes_attr', '__return_false', PHP_INT_MAX);
            if(isset($themify_save)){
                $GLOBALS['themify'] = clone $themify_save;
                $themify_save=null;
            }
        }
	endif;
	?>
	<?php if(empty($related_products) && (Tbp_Utils::$isActive===true || Themify_Builder::$frontedit_active===true)):?>
	    <div class="tbp_empty_module">
		<?php echo Themify_Builder_Model::get_module_name($mod_name);?>
	    </div>
	<?php endif; ?>
    </div>
    <!-- /Related Products module -->
<?php endif; ?>
